﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.IO;
using at.uba.uwwtd2008.xml;

namespace at.uba.uwwtd2008.DataAccess
{
    class InterfaceUWWTP : InterfaceBase
    {
        public InterfaceUWWTP(IDbConnection conn, IDbTransaction trans, DataFormatConverter conv)
            : base(conn, trans, conv)
        {
        }

        private string []uwwFldNames = {"uwwState", "repCode", "aggID", "uwwCode", "uwwName", "uwwCollectingSystem",
	            "uwwDateClosing", "uwwHistorie", "uwwLatitude", "uwwLongitude", "uwwNUTS", "uwwLoadEnteringUWWTP", "uwwCapacity",
	            "uwwPrimaryTreatment", "uwwSecondaryTreatment", "uwwOtherTreatment", "uwwNRemoval", "uwwPRemoval", "uwwUV",
	            "uwwChlorination", "uwwOzonation", "uwwSandFiltration", "uwwMicroFiltration", "uwwOther", "uwwSpecification",
	            "uwwBOD5Perf", "uwwCODPerf", "uwwTSSPerf", "uwwNTotPerf", "uwwPTotPerf", "uwwOtherPerf", "uwwBadPerformance",
	            "uwwAccidents", "uwwBadDesign", "uwwInformation", "uwwBODIncomingMeasured", "uwwBODIncomingCalculated",
	            "uwwBODIncomingEstimated", "uwwCODIncomingMeasured", "uwwCODIncomingCalculated", "uwwCODIncomingEstimated",
	            "uwwNIncomingMeasured", "uwwNIncomingCalculated", "uwwNIncomingEstimated", "uwwPIncomingMeasured",
	            "uwwPIncomingCalculated", "uwwPIncomingEstimated", "uwwBODDischargedMeasured", "uwwBODDischargedCalculated",
	            "uwwBODDischargedEstimated", "uwwCODDischargedMeasured", "uwwCODDischargedCalculated", "uwwCODDischargedEstimated",
	            "uwwNDischargedMeasured", "uwwNDischargedCalculated", "uwwNDischargedEstimated", "uwwPDischargedMeasured",
	            "uwwPDischargedCalculated", "uwwPDischargedEstimated", "uwwWasteWaterTreated", "uwwMethodWasteWaterTreated",
	            "uwwRemarks", "exportDate"};

        private IDbCommand CreateCommand()
        {
            string strSQL = "INSERT INTO T_UWWTPS ( uwwState, repID, aggID, uwwCode, uwwName, uwwCollectingSystem, uwwDateClosing, uwwHistorie, " +
             "uwwLatitude, uwwLongitude, uwwNUTS, uwwLoadEnteringUWWTP, uwwCapacity, uwwPrimaryTreatment, uwwSecondaryTreatment, " +
             "uwwOtherTreatment, uwwNRemoval, uwwPRemoval, uwwUV, uwwChlorination, uwwOzonation, uwwSandFiltration, uwwMicroFiltration, " +
             "uwwOther, uwwSpecification, uwwBOD5Perf, uwwCODPerf, uwwTSSPerf, uwwNTotPerf, uwwPTotPerf, uwwOtherPerf, uwwBadPerformance, " +
             "uwwAccidents, uwwBadDesign, uwwInformation, uwwBODIncomingMeasured, uwwBODIncomingCalculated, uwwBODIncomingEstimated, " +
             "uwwCODIncomingMeasured, uwwCODIncomingCalculated, uwwCODIncomingEstimated, uwwNIncomingMeasured, uwwNIncomingCalculated, " +
             "uwwNIncomingEstimated, uwwPIncomingMeasured, uwwPIncomingCalculated, uwwPIncomingEstimated, uwwBODDischargedMeasured, " +
             "uwwBODDischargedCalculated, uwwBODDischargedEstimated, uwwCODDischargedMeasured, uwwCODDischargedCalculated, " +
             "uwwCODDischargedEstimated, uwwNDischargedMeasured, uwwNDischargedCalculated, uwwNDischargedEstimated, uwwPDischargedMeasured, " +
             "uwwPDischargedCalculated, uwwPDischargedEstimated, uwwWasteWaterTreated, uwwMethodWasteWaterTreated, uwwRemarks) " +
             "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, " +
             "?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?);";

            IDbCommand comInsCmd = dataFactory.CreateCommand(strSQL, conn, trans);
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwState", DbType.Int64, 0, "uwwState", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@repID", DbType.Int64, 0, "repID", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@aggID", DbType.Int64, 0, "aggID", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwCode", DbType.String, 32, "uwwCode", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwName", DbType.String, 255, "uwwName", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwCollectingSystem", DbType.Int64, 0, "uwwCollectingSystem", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwDateClosing", DbType.String, 16, "uwwDateClosing", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwHistorie", DbType.String, 4096, "uwwHistorie", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwLatitude", DbType.String, 20, "uwwLatitude", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwLongitude", DbType.String, 20, "uwwLongitude", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwNUTS", DbType.Int64, 0, "uwwNUTS", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwLoadEnteringUWWTP", DbType.Int64, 0, "uwwLoadEnteringUWWTP", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwCapacity", DbType.Int64, 0, "uwwCapacity", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwPrimaryTreatment", DbType.Boolean, 0, "uwwPrimaryTreatment", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwSecondaryTreatment", DbType.Boolean, 0, "uwwSecondaryTreatment", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwOtherTreatment", DbType.Boolean, 0, "uwwOtherTreatment", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwNRemoval", DbType.Boolean, 0, "uwwNRemoval", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwPRemoval", DbType.Boolean, 0, "uwwPRemoval", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwUV", DbType.Boolean, 0, "uwwUV", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwChlorination", DbType.Boolean, 0, "uwwChlorination", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwOzonation", DbType.Boolean, 0, "uwwOzonation", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwSandFiltration", DbType.Boolean, 0, "uwwSandFiltration", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwMicroFiltration", DbType.Boolean, 0, "uwwMicroFiltration", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwOther", DbType.Boolean, 0, "uwwOther", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwSpecification", DbType.String, 128, "uwwSpecification", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwBOD5Perf", DbType.Int64, 0, "uwwBOD5Perf", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwCODPerf", DbType.Int64, 0, "uwwCODPerf", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwTSSPerf", DbType.Int64, 0, "uwwTSSPerf", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwNTotPerf", DbType.Int64, 0, "uwwNTotPerf", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwPTotPerf", DbType.Int64, 0, "uwwPTotPerf", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwOtherPerf", DbType.Int64, 0, "uwwOtherPerf", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwBadPerformance", DbType.Boolean, 0, "uwwBadPerformance", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwAccidents", DbType.Boolean, 0, "uwwAccidents", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwBadDesign", DbType.Boolean, 0, "uwwBadDesign", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwInformation", DbType.String, 4096, "uwwInformation", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwBODIncomingMeasured", DbType.Double, 0, "uwwBODIncomingMeasured", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwBODIncomingCalculated", DbType.Double, 0, "uwwBODIncomingCalculated", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwBODIncomingEstimated", DbType.Double, 0, "uwwBODIncomingEstimated", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwCODIncomingMeasured", DbType.Double, 0, "uwwCODIncomingMeasured", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwCODIncomingCalculated", DbType.Double, 0, "uwwCODIncomingCalculated", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwCODIncomingEstimated", DbType.Double, 0, "uwwCODIncomingEstimated", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwNIncomingMeasured", DbType.Double, 0, "uwwNIncomingMeasured", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwNIncomingCalculated", DbType.Double, 0, "uwwNIncomingCalculated", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwNIncomingEstimated", DbType.Double, 0, "uwwNIncomingEstimated", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwPIncomingMeasured", DbType.Double, 0, "uwwPIncomingMeasured", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwPIncomingCalculated", DbType.Double, 0, "uwwPIncomingCalculated", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwPIncomingEstimated", DbType.Double, 0, "uwwPIncomingEstimated", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwBODDischargedMeasured", DbType.Double, 0, "uwwBODDischargedMeasured", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwBODDischargedCalculated", DbType.Double, 0, "uwwBODDischargedCalculated", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwBODDischargedEstimated", DbType.Double, 0, "uwwBODDischargedEstimated", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwCODDischargedMeasured", DbType.Double, 0, "uwwCODDischargedMeasured", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwCODDischargedCalculated", DbType.Double, 0, "uwwCODDischargedCalculated", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwCODDischargedEstimated", DbType.Double, 0, "uwwCODDischargedEstimated", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwNDischargedMeasured", DbType.Double, 0, "uwwNDischargedMeasured", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwNDischargedCalculated", DbType.Double, 0, "uwwNDischargedCalculated", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwNDischargedEstimated", DbType.Double, 0, "uwwNDischargedEstimated", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwPDischargedMeasured", DbType.Double, 0, "uwwPDischargedMeasured", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwPDischargedCalculated", DbType.Double, 0, "uwwPDischargedCalculated", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwPDischargedEstimated", DbType.Double, 0, "uwwPDischargedEstimated", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwWasteWaterTreated", DbType.Double, 0, "uwwWasteWaterTreated", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwMethodWasteWaterTreated", DbType.Int64, 0, "uwwMethodWasteWaterTreated", null));
            comInsCmd.Parameters.Add(dataFactory.CreateParameter("@uwwRemarks", DbType.String, 4096, "uwwRemarks", null));

            return comInsCmd;
        }

        private IDbCommand CreateSelectCommand()
        {
            string strSQL = "SELECT uwwState, repID, aggID, uwwCode, uwwName, uwwCollectingSystem, uwwDateClosing, uwwHistorie, " +
             "uwwLatitude, uwwLongitude, uwwNUTS, uwwLoadEnteringUWWTP, uwwCapacity, uwwPrimaryTreatment, uwwSecondaryTreatment, " +
             "uwwOtherTreatment, uwwNRemoval, uwwPRemoval, uwwUV, uwwChlorination, uwwOzonation, uwwSandFiltration, uwwMicroFiltration, " +
             "uwwOther, uwwSpecification, uwwBOD5Perf, uwwCODPerf, uwwTSSPerf, uwwNTotPerf, uwwPTotPerf, uwwOtherPerf, uwwBadPerformance, " +
             "uwwAccidents, uwwBadDesign, uwwInformation, uwwBODIncomingMeasured, uwwBODIncomingCalculated, uwwBODIncomingEstimated, " +
             "uwwCODIncomingMeasured, uwwCODIncomingCalculated, uwwCODIncomingEstimated, uwwNIncomingMeasured, uwwNIncomingCalculated, " +
             "uwwNIncomingEstimated, uwwPIncomingMeasured, uwwPIncomingCalculated, uwwPIncomingEstimated, uwwBODDischargedMeasured, " +
             "uwwBODDischargedCalculated, uwwBODDischargedEstimated, uwwCODDischargedMeasured, uwwCODDischargedCalculated, " +
             "uwwCODDischargedEstimated, uwwNDischargedMeasured, uwwNDischargedCalculated, uwwNDischargedEstimated, uwwPDischargedMeasured, " +
             "uwwPDischargedCalculated, uwwPDischargedEstimated, uwwWasteWaterTreated, uwwMethodWasteWaterTreated, uwwRemarks " +
             "FROM T_UWWTPS WHERE repID = ?;";

            IDbCommand comSelCmd = dataFactory.CreateCommand(strSQL, conn, trans);

            comSelCmd.Parameters.Add(dataFactory.CreateParameter("@repID", DbType.Int64, 0, "repID", null));

            return comSelCmd;        
        }

        public override void importData(StreamReader rdr, DataRow repPeriod)
        {
            System.Collections.ArrayList lstUniqAggCodes = new System.Collections.ArrayList();
            IDbCommand comAgglo = dataFactory.CreateCommand("SELECT aggID FROM T_Agglomerations WHERE aggCode = ?;", conn, trans);
            IDataParameter parAggCode = dataFactory.CreateParameter("@aggCode", DbType.String, 32, "aggCode", null);
            comAgglo.Parameters.Add(parAggCode);

            logInfo("========================================================================");
            logInfo("  Importing UWWTPs");
            logInfo("========================================================================");
            string line;
            int lineNo = 0;
            while ((line = rdr.ReadLine()) != null)
            {
                try
                {
                    lineNo++;
                    line = line.TrimEnd();
                    if (line.Length < 1) continue; // ignore empty lines
                    string[] parts = line.Split(new string[] { "\t" }, StringSplitOptions.None);

                    IDbCommand cmd = CreateCommand();
                    for (int idx = 0; idx < parts.Length; idx++)
                    {
                        if (idx >= uwwFldNames.Length)
                        {
                            // do error reporting ("too many items")
                            continue;
                        }
                        string strFeldName = uwwFldNames[idx];
                        if (strFeldName.Equals("exportDate")) // this is nothing to import
                            continue;
                        object objTemp = parts[idx];
                        if (parts[idx].Length > 0)
                        {
                            //blnRefValue = true;
                            switch (strFeldName)
                            {
                                case "repCode":
                                    objTemp = dataFactory.getRepIDforReportCode(parts[idx]);
                                    // if (objTemp == null)  do error reporting
                                    setParameterValue(cmd, idx, objTemp);
                                    break;
                                case "uwwState":
                                    objTemp = dataFactory.getLovRowByKey("STAT", parts[idx])["lovID"];
                                    // if (objTemp == null) do error reporting
                                    setParameterValue(cmd, idx, objTemp);
                                    break;
                                case "uwwCode":
                                    if (lstUniqAggCodes.Contains(parts[idx]))
                                    {
                                        //strFCode = "INVKEY"
                                        //strFeldName = "rcaCode"
                                        //strWert = CStr(colRcaInp(intColCnt))
                                        //Err.Raise(10000)
                                    }
                                    else
                                    {
                                        setParameterValue(cmd, idx, parts[idx]);
                                    }
                                    break;
                                case "aggID":
                                    if (!parts[idx].Equals(""))
                                    {
                                        parAggCode.Value = parts[idx];
                                        objTemp = comAgglo.ExecuteScalar();
                                    }
                                    else objTemp = DBNull.Value;
                                    setParameterValue(cmd, idx, objTemp);
                                    break;
                                case "uwwCollectingSystem":
                                    objTemp = dataFactory.getLovRowByKey("UWWTP", parts[idx])["lovID"];
                                    // if (objTemp == null) do error reporting
                                    setParameterValue(cmd, idx, objTemp);
                                    break;
                                case "uwwNUTS":
                                    objTemp = dataFactory.getNUTSIdForNUTSCode(parts[idx]);
                                    // if (objTemp == null) do error reporting
                                    setParameterValue(cmd, idx, objTemp);
                                    break;
                                case "uwwBOD5Perf":
                                    objTemp = dataFactory.getLovRowByKey("BOD5", parts[idx])["lovID"];
                                    // if (objTemp == null) do error reporting
                                    setParameterValue(cmd, idx, objTemp);
                                    break;
                                case "uwwCODPerf":
                                    objTemp = dataFactory.getLovRowByKey("PASS", parts[idx])["lovID"];
                                    // if (objTemp == null) do error reporting
                                    setParameterValue(cmd, idx, objTemp);
                                    break;
                                case "uwwTSSPerf":
                                    objTemp = dataFactory.getLovRowByKey("PASS", parts[idx])["lovID"];
                                    // if (objTemp == null) do error reporting
                                    setParameterValue(cmd, idx, objTemp);
                                    break;
                                case "uwwNTotPerf":
                                    objTemp = dataFactory.getLovRowByKey("PASS", parts[idx])["lovID"];
                                    // if (objTemp == null) do error reporting
                                    setParameterValue(cmd, idx, objTemp);
                                    break;
                                case "uwwPTotPerf":
                                    objTemp = dataFactory.getLovRowByKey("PASS", parts[idx])["lovID"];
                                    // if (objTemp == null) do error reporting
                                    setParameterValue(cmd, idx, objTemp);
                                    break;
                                case "uwwOtherPerf":
                                    objTemp = dataFactory.getLovRowByKey("PASS", parts[idx])["lovID"];
                                    // if (objTemp == null) do error reporting
                                    setParameterValue(cmd, idx, objTemp);
                                    break;
                                case "uwwMethodWasteWaterTreated":
                                    objTemp = dataFactory.getLovRowByKey("LOADDET", parts[idx])["lovID"];
                                    // if (objTemp == null) do error reporting
                                    setParameterValue(cmd, idx, objTemp);
                                    break;
                                default:
                                    setParameterValue(cmd, idx, parts[idx]);
                                    break;
                            }
                        }
                        else
                        {
                            setParameterValue(cmd, idx, null);
                        }
                    }

                    cmd.ExecuteNonQuery();
                    reportSuccess();
                }
                catch (Exception ex)
                {
                    logError("Exception: " + ex.Message + ";");
                    reportFail();
                }
            }
        }

        public override void exportData(StreamWriter wr, DataRow repPeriod)
        {
            IDbCommand cmd = CreateSelectCommand();
            IDbCommand comAgglo = dataFactory.CreateCommand("SELECT aggCode FROM T_Agglomerations WHERE aggID = ?;", conn, trans);
            IDataParameter parAggID = dataFactory.CreateParameter("@aggID", DbType.String, 32, "aggID", null);
            comAgglo.Parameters.Add(parAggID);

            string[] parts = new string[uwwFldNames.Length];

            logInfo("========================================================================");
            logInfo("  Exporting UWWTP");
            logInfo("========================================================================");


            setParameterValue(cmd, "@repID", repPeriod["repID"]);
            IDataReader rdr = cmd.ExecuteReader();
            try
            {
                while (rdr.Read())
                {
                    try
                    {
                        bool hasErrors = false;
                        for (int i = 0; i < uwwFldNames.Length; i++)
                        {
                            string strFieldName = uwwFldNames[i];
                            if (strFieldName.Equals("exportDate")) continue;
                            if ((!strFieldName.Equals("repCode")) && (!strFieldName.Equals("rptMStateKey")))
                                if (!checkQAACRule(rdr[strFieldName], strFieldName, repPeriod, false, null))
                                    hasErrors = true;

                            switch (strFieldName)
                            {
                                case "repCode":
                                    parts[i] = getReaderValueString(repPeriod["repCode"]);
                                    break;
                                case "uwwState":
                                    parts[i] = dataFactory.getLovRowByID(rdr[i])["lovKey"] as string;
                                    break;
                                case "aggID":
                                    if (!(rdr[i] is DBNull)) {
                                        parAggID.Value = rdr[i];
                                        parts[i] = getReaderValueString(comAgglo.ExecuteScalar());
                                    }
                                    else parts[i] = getReaderValueString(DBNull.Value);
                                    break;
                                case "uwwLongitude":
                                case "uwwLatitude":
                                    parts[i] = getReaderValueString(DataAccessFactory.parseDBDecimal(rdr[i]));
                                    break;
                                case "uwwCollectingSystem":
                                    parts[i] = dataFactory.getLovRowByID(rdr[i])["lovKey"] as string;
                                    break;
                                case "uwwNUTS":
                                    parts[i] = dataFactory.getNutsCode(rdr[i]);
                                    break;
                                case "uwwBOD5Perf":
                                    parts[i] = dataFactory.getLovRowByID(rdr[i])["lovKey"] as string;
                                    break;
                                case "uwwCODPerf":
                                    parts[i] = dataFactory.getLovRowByID(rdr[i])["lovKey"] as string;
                                    break;
                                case "uwwTSSPerf":
                                    parts[i] = dataFactory.getLovRowByID(rdr[i])["lovKey"] as string;
                                    break;
                                case "uwwNTotPerf":
                                    parts[i] = dataFactory.getLovRowByID(rdr[i])["lovKey"] as string;
                                    break;
                                case "uwwPTotPerf":
                                    parts[i] = dataFactory.getLovRowByID(rdr[i])["lovKey"] as string;
                                    break;
                                case "uwwOtherPerf":
                                    parts[i] = dataFactory.getLovRowByID(rdr[i])["lovKey"] as string;
                                    break;
                                case "uwwMethodWasteWaterTreated":
                                    parts[i] = dataFactory.getLovRowByID(rdr[i])["lovKey"] as string;
                                    break;
                                default:
                                    parts[i] = getReaderValueString(rdr[i]);
                                    break;
                            }
                        }
                        parts[parts.Length - 1] = conv.formatDateLong(DateTime.Now);
                        wr.WriteLine(string.Join("\t", parts));
                        if (!hasErrors)
                            reportSuccess();
                        else
                            reportFail();
                    }
                    catch (Exception ex)
                    {
                        logError("Export UWWTP " + rdr["uwwCode"] + " caused Exception: " + ex.Message);
                        reportFail();
                    }
                }
            }
            finally
            {
                rdr.Close();
            }
        }

        public override void exportXML(UWWTD_DataUWWTD_Report report, DataRow repPeriod)
        {
            List<UWWTD_DataUWWTD_ReportUWWTP> dataList = new List<UWWTD_DataUWWTD_ReportUWWTP>();

            IDbCommand cmd = CreateSelectCommand();
            IDbCommand comAgglo = dataFactory.CreateCommand("SELECT aggCode FROM T_Agglomerations WHERE aggID = ?;", conn, trans);
            IDataParameter parAggID = dataFactory.CreateParameter("@aggID", DbType.String, 32, "aggID", null);
            comAgglo.Parameters.Add(parAggID);

            logInfo("========================================================================");
            logInfo("  Importing UWWTDs for ReportPeriod " + repPeriod["repCode"]);
            logInfo("========================================================================");

            setParameterValue(cmd, "@repID", repPeriod["repID"]);
            IDataReader rdr = cmd.ExecuteReader();
            while (rdr.Read())
            {
                bool hasErrors = false;
                try
                {
                    for (int j = 0; j < uwwFldNames.Length; j++)
                    {
                        if (uwwFldNames[j].Equals("exportDate")) continue;
                        if (!checkQAACRule(rdr[j], uwwFldNames[j], repPeriod, false, null))
                            hasErrors = true;
                    }
                    UWWTD_DataUWWTD_ReportUWWTP data = new UWWTD_DataUWWTD_ReportUWWTP();

                    data.uwwState = dataFactory.getLovRowByID(rdr["uwwState"])["lovKey"] as string;
                    data.uwwCode = rdr["uwwCode"] as string;
                    data.uwwName = rdr["uwwName"] as string;
                    if (!(rdr["aggID"] is DBNull))
                    {
                        parAggID.Value = rdr["aggID"];
                        data.aggID = comAgglo.ExecuteScalar() as string;
                    }

                    if (rdr["uwwCollectingSystem"] is DBNull)
                        data.uwwCollectingSystem = null;
                    else
                        data.uwwCollectingSystem = dataFactory.getLovRowByID(rdr["uwwCollectingSystem"])["lovKey"] as string;

                    data.uwwDateClosing = rdr["uwwDateClosing"] as string;
                    data.uwwHistorie = rdr["uwwHistorie"] as string;

                    data.uwwLatitudeSpecified = !(rdr["uwwLatitude"] is DBNull);
                    if (data.uwwLatitudeSpecified)
                        data.uwwLatitude = (decimal)DataAccessFactory.parseDBDecimal(rdr["uwwLatitude"]);
                    data.uwwLongitudeSpecified = !((rdr["uwwLongitude"] is DBNull));
                    if (data.uwwLongitudeSpecified)
                        data.uwwLongitude = (decimal)DataAccessFactory.parseDBDecimal(rdr["uwwLongitude"]);
                    if (rdr["uwwNUTS"] is DBNull)
                        data.uwwNUTS = null;
                    else
                        data.uwwNUTS = dataFactory.getNutsCode(rdr["uwwNUTS"]) as string;
                    data.uwwLoadEnteringUWWTPSpecified = true;
                    if (rdr["uwwLoadEnteringUWWTP"] is DBNull)
                        data.uwwLoadEnteringUWWTPSpecified = false;
                    else
                        data.uwwLoadEnteringUWWTP = long.Parse(rdr["uwwLoadEnteringUWWTP"].ToString());

                    data.uwwCapacitySpecified = true;
                    if (rdr["uwwCapacity"] is DBNull)
                        data.uwwCapacitySpecified = false;
                    else
                        data.uwwCapacity = long.Parse(rdr["uwwCapacity"].ToString());

                    data.uwwPrimaryTreatmentSpecified = true;
                    if (rdr["uwwPrimaryTreatment"] is DBNull)
                        data.uwwPrimaryTreatmentSpecified = false;
                    else
                        data.uwwPrimaryTreatment = ((bool)rdr["uwwPrimaryTreatment"]);
                    data.uwwSecondaryTreatmentSpecified = true;
                    if (rdr["uwwSecondaryTreatment"] is DBNull)
                        data.uwwSecondaryTreatmentSpecified = false;
                    else
                        data.uwwSecondaryTreatment = ((bool)rdr["uwwSecondaryTreatment"]);
                    data.uwwOtherTreatmentSpecified = true;
                    if (rdr["uwwOtherTreatment"] is DBNull)
                        data.uwwOtherTreatmentSpecified = false;
                    else
                        data.uwwOtherTreatment = ((bool)rdr["uwwOtherTreatment"]);
                    data.uwwNRemovalSpecified = true;
                    if (rdr["uwwNRemoval"] is DBNull)
                        data.uwwNRemovalSpecified = false;
                    else
                        data.uwwNRemoval = ((bool)rdr["uwwNRemoval"]);
                    data.uwwPRemovalSpecified = true;
                    if (rdr["uwwPRemoval"] is DBNull)
                        data.uwwPRemovalSpecified = false;
                    else
                        data.uwwPRemoval = ((bool)rdr["uwwPRemoval"]);
                    data.uwwUVSpecified = true;
                    if (rdr["uwwUV"] is DBNull)
                        data.uwwUVSpecified = false;
                    else
                        data.uwwUV = ((bool)rdr["uwwUV"]);
                    data.uwwChlorinationSpecified = true;
                    if (rdr["uwwChlorination"] is DBNull)
                        data.uwwChlorinationSpecified = false;
                    else
                        data.uwwChlorination = ((bool)rdr["uwwChlorination"]);
                    data.uwwOzonationSpecified = true;
                    if (rdr["uwwOzonation"] is DBNull)
                        data.uwwOzonationSpecified = false;
                    else
                        data.uwwOzonation = ((bool)rdr["uwwOzonation"]);
                    data.uwwSandFiltrationSpecified = true;
                    if (rdr["uwwSandFiltration"] is DBNull)
                        data.uwwSandFiltrationSpecified = false;
                    else
                        data.uwwSandFiltration = ((bool)rdr["uwwSandFiltration"]);
                    data.uwwMicroFiltrationSpecified = true;
                    if (rdr["uwwMicroFiltration"] is DBNull)
                        data.uwwMicroFiltrationSpecified = false;
                    else
                        data.uwwMicroFiltration = ((bool)rdr["uwwMicroFiltration"]);
                    data.uwwOtherSpecified = true;
                    if (rdr["uwwOther"] is DBNull)
                        data.uwwOtherSpecified = false;
                    else
                        data.uwwOther = ((bool)rdr["uwwOther"]);

                    data.uwwSpecification = rdr["uwwSpecification"] as string;

                    if (rdr["uwwBOD5Perf"] is DBNull)
                        data.uwwBOD5Perf = null;
                    else
                        data.uwwBOD5Perf = dataFactory.getLovRowByID(rdr["uwwBOD5Perf"])["lovKey"] as string;
                    if (rdr["uwwCODPerf"] is DBNull)
                        data.uwwCODPerf = null;
                    else
                        data.uwwCODPerf = dataFactory.getLovRowByID(rdr["uwwCODPerf"])["lovKey"] as string;
                    if (rdr["uwwTSSPerf"] is DBNull)
                        data.uwwTSSPerf = null;
                    else
                        data.uwwTSSPerf = dataFactory.getLovRowByID(rdr["uwwTSSPerf"])["lovKey"] as string;
                    if (rdr["uwwNTotPerf"] is DBNull)
                        data.uwwNTotPerf = null;
                    else
                        data.uwwNTotPerf = dataFactory.getLovRowByID(rdr["uwwNTotPerf"])["lovKey"] as string;
                    if (rdr["uwwPTotPerf"] is DBNull)
                        data.uwwPTotPerf = null;
                    else
                        data.uwwPTotPerf = dataFactory.getLovRowByID(rdr["uwwPTotPerf"])["lovKey"] as string;
                    if (rdr["uwwOtherPerf"] is DBNull)
                        data.uwwOtherPerf = null;
                    else
                        data.uwwOtherPerf = dataFactory.getLovRowByID(rdr["uwwOtherPerf"])["lovKey"] as string;
                    data.uwwBadPerformanceSpecified = true;
                    if (rdr["uwwBadPerformance"] is DBNull)
                        data.uwwBadPerformanceSpecified = false;
                    else
                        data.uwwBadPerformance = ((bool)rdr["uwwBadPerformance"]);
                    data.uwwAccidentsSpecified = true;
                    if (rdr["uwwAccidents"] is DBNull)
                        data.uwwAccidentsSpecified = false;
                    else
                        data.uwwAccidents = ((bool)rdr["uwwAccidents"]);
                    data.uwwBadDesignSpecified = true;
                    if (rdr["uwwBadDesign"] is DBNull)
                        data.uwwBadDesignSpecified = false;
                    else
                        data.uwwBadDesign = ((bool)rdr["uwwBadDesign"]);

                    data.uwwInformation = rdr["uwwInformation"] as string;

                    data.uwwBODIncomingMeasuredSpecified = true;
                    if (rdr["uwwBODIncomingMeasured"] is DBNull)
                        data.uwwBODIncomingMeasuredSpecified = false;
                    else
                        data.uwwBODIncomingMeasured = (decimal)double.Parse(rdr["uwwBODIncomingMeasured"].ToString());
                    data.uwwBODIncomingEstimatedSpecified = true;
                    if (rdr["uwwBODIncomingEstimated"] is DBNull)
                        data.uwwBODIncomingEstimatedSpecified = false;
                    else
                        data.uwwBODIncomingEstimated = (decimal)double.Parse(rdr["uwwBODIncomingEstimated"].ToString());
                    data.uwwBODIncomingCalculatedSpecified = true;
                    if (rdr["uwwBODIncomingCalculated"] is DBNull)
                        data.uwwBODIncomingCalculatedSpecified = false;
                    else
                        data.uwwBODIncomingCalculated = (decimal)double.Parse(rdr["uwwBODIncomingCalculated"].ToString());
                    data.uwwCODIncomingMeasuredSpecified = true;
                    if (rdr["uwwCODIncomingMeasured"] is DBNull)
                        data.uwwCODIncomingMeasuredSpecified = false;
                    else
                        data.uwwCODIncomingMeasured = (decimal)double.Parse(rdr["uwwCODIncomingMeasured"].ToString());
                    data.uwwCODIncomingEstimatedSpecified = true;
                    if (rdr["uwwCODIncomingEstimated"] is DBNull)
                        data.uwwCODIncomingEstimatedSpecified = false;
                    else
                        data.uwwCODIncomingEstimated = (decimal)double.Parse(rdr["uwwCODIncomingEstimated"].ToString());
                    data.uwwCODIncomingCalculatedSpecified = true;
                    if (rdr["uwwCODIncomingCalculated"] is DBNull)
                        data.uwwCODIncomingCalculatedSpecified = false;
                    else
                        data.uwwCODIncomingCalculated = (decimal)double.Parse(rdr["uwwCODIncomingCalculated"].ToString());
                    data.uwwNIncomingMeasuredSpecified = true;
                    if (rdr["uwwNIncomingMeasured"] is DBNull)
                        data.uwwNIncomingMeasuredSpecified = false;
                    else
                        data.uwwNIncomingMeasured = (decimal)double.Parse(rdr["uwwNIncomingMeasured"].ToString());
                    data.uwwNIncomingEstimatedSpecified = true;
                    if (rdr["uwwNIncomingEstimated"] is DBNull)
                        data.uwwNIncomingEstimatedSpecified = false;
                    else
                        data.uwwNIncomingEstimated = (decimal)double.Parse(rdr["uwwNIncomingEstimated"].ToString());
                    data.uwwNIncomingCalculatedSpecified = true;
                    if (rdr["uwwNIncomingCalculated"] is DBNull)
                        data.uwwNIncomingCalculatedSpecified = false;
                    else
                        data.uwwNIncomingCalculated = (decimal)double.Parse(rdr["uwwNIncomingCalculated"].ToString());
                    data.uwwPIncomingMeasuredSpecified = true;
                    if (rdr["uwwPIncomingMeasured"] is DBNull)
                        data.uwwPIncomingMeasuredSpecified = false;
                    else
                        data.uwwPIncomingMeasured = (decimal)double.Parse(rdr["uwwPIncomingMeasured"].ToString());
                    data.uwwPIncomingEstimatedSpecified = true;
                    if (rdr["uwwPIncomingEstimated"] is DBNull)
                        data.uwwPIncomingEstimatedSpecified = false;
                    else
                        data.uwwPIncomingEstimated = (decimal)double.Parse(rdr["uwwPIncomingEstimated"].ToString());
                    data.uwwPIncomingCalculatedSpecified = true;
                    if (rdr["uwwPIncomingCalculated"] is DBNull)
                        data.uwwPIncomingCalculatedSpecified = false;
                    else
                        data.uwwPIncomingCalculated = (decimal)double.Parse(rdr["uwwPIncomingCalculated"].ToString());

                    data.uwwBODDischargeMeasuredSpecified = true;
                    if (rdr["uwwBODDischargedMeasured"] is DBNull)
                        data.uwwBODDischargeMeasuredSpecified = false;
                    else
                        data.uwwBODDischargeMeasured = (decimal)double.Parse(rdr["uwwBODDischargedMeasured"].ToString());
                    data.uwwBODDischargeEstimatedSpecified = true;
                    if (rdr["uwwBODDischargedEstimated"] is DBNull)
                        data.uwwBODDischargeEstimatedSpecified = false;
                    else
                        data.uwwBODDischargeEstimated = (decimal)double.Parse(rdr["uwwBODDischargedEstimated"].ToString());
                    data.uwwBODDischargeCalculatedSpecified = true;
                    if (rdr["uwwBODDischargedCalculated"] is DBNull)
                        data.uwwBODDischargeCalculatedSpecified = false;
                    else
                        data.uwwBODDischargeCalculated = (decimal)double.Parse(rdr["uwwBODDischargedCalculated"].ToString());
                    data.uwwCODDischargeMeasuredSpecified = true;
                    if (rdr["uwwCODDischargedMeasured"] is DBNull)
                        data.uwwCODDischargeMeasuredSpecified = false;
                    else
                        data.uwwCODDischargeMeasured = (decimal)double.Parse(rdr["uwwCODDischargedMeasured"].ToString());
                    data.uwwCODDischargeEstimatedSpecified = true;
                    if (rdr["uwwCODDischargedEstimated"] is DBNull)
                        data.uwwCODDischargeEstimatedSpecified = false;
                    else
                        data.uwwCODDischargeEstimated = (decimal)double.Parse(rdr["uwwCODDischargedEstimated"].ToString());
                    data.uwwCODDischargeCalculatedSpecified = true;
                    if (rdr["uwwCODDischargedCalculated"] is DBNull)
                        data.uwwCODDischargeCalculatedSpecified = false;
                    else
                        data.uwwCODDischargeCalculated = (decimal)double.Parse(rdr["uwwCODDischargedCalculated"].ToString());
                    data.uwwNDischargeMeasuredSpecified = true;
                    if (rdr["uwwNDischargedMeasured"] is DBNull)
                        data.uwwNDischargeMeasuredSpecified = false;
                    else
                        data.uwwNDischargeMeasured = (decimal)double.Parse(rdr["uwwNDischargedMeasured"].ToString());
                    data.uwwNDischargeEstimatedSpecified = true;
                    if (rdr["uwwNDischargedEstimated"] is DBNull)
                        data.uwwNDischargeEstimatedSpecified = false;
                    else
                        data.uwwNDischargeEstimated = (decimal)double.Parse(rdr["uwwNDischargedEstimated"].ToString());
                    data.uwwNDischargeCalculatedSpecified = true;
                    if (rdr["uwwNDischargedCalculated"] is DBNull)
                        data.uwwNDischargeCalculatedSpecified = false;
                    else
                        data.uwwNDischargeCalculated = (decimal)double.Parse(rdr["uwwNDischargedCalculated"].ToString());
                    data.uwwPDischargeMeasuredSpecified = true;
                    if (rdr["uwwPDischargedMeasured"] is DBNull)
                        data.uwwPDischargeMeasuredSpecified = false;
                    else
                        data.uwwPDischargeMeasured = (decimal)double.Parse(rdr["uwwPDischargedMeasured"].ToString());
                    data.uwwPDischargeEstimatedSpecified = true;
                    if (rdr["uwwPDischargedEstimated"] is DBNull)
                        data.uwwPDischargeEstimatedSpecified = false;
                    else
                        data.uwwPDischargeEstimated = (decimal)double.Parse(rdr["uwwPDischargedEstimated"].ToString());
                    data.uwwPDischargeCalculatedSpecified = true;
                    if (rdr["uwwPDischargedCalculated"] is DBNull)
                        data.uwwPDischargeCalculatedSpecified = false;
                    else
                        data.uwwPDischargeCalculated = (decimal)double.Parse(rdr["uwwPDischargedCalculated"].ToString());

                    data.uwwWasteWaterTreatedSpecified = true;
                    if (rdr["uwwWasteWaterTreated"] is DBNull)
                        data.uwwWasteWaterTreatedSpecified = false;
                    else
                        data.uwwWasteWaterTreated = (decimal)double.Parse(rdr["uwwWasteWaterTreated"].ToString());

                    if (rdr["uwwMethodWasteWaterTreated"] is DBNull)
                        data.uwwMethodWasteWaterTreated = null;
                    else
                        data.uwwMethodWasteWaterTreated = dataFactory.getLovRowByID(rdr["uwwMethodWasteWaterTreated"])["lovKey"] as string;

                    data.uwwRemarks = rdr["uwwRemarks"] as string;

                    dataList.Add(data);
                    if (hasErrors)
                        reportFail();
                    else
                        reportSuccess();

                }
                catch (Exception ex)
                {
                    logError("Exception: " + ex.ToString());
                    reportFail();
                }
            }
            report.UWWTPs = dataList.ToArray();
        }

        public override void importXML(object collection, DataRow repPeriod)
        {
            UWWTD_DataUWWTD_ReportUWWTP[] uwwtps = collection as UWWTD_DataUWWTD_ReportUWWTP[];
            System.Collections.ArrayList lstUniqCodes = new System.Collections.ArrayList();
            
            IDbCommand cmdAgglo = dataFactory.CreateCommand("SELECT aggID FROM T_Agglomerations WHERE aggCode = ?;", conn, trans);
            IDataParameter parAgglo = dataFactory.CreateParameter("@aggCode", DbType.String, 32, "aggCode", null);
            cmdAgglo.Parameters.Add(parAgglo);
            IDbCommand cmdBigCity = dataFactory.CreateCommand("SELECT bigID FROM T_BigCity WHERE bigCityID = ?;", conn, trans);
            IDataParameter parBigCity = dataFactory.CreateParameter("@bigCityID", DbType.String, 32, "bigCityID", null);
            cmdBigCity.Parameters.Add(parBigCity);

            logInfo("========================================================================");
            logInfo("  Importing UWWTPs");
            logInfo("========================================================================");

            IDbCommand cmd = CreateCommand();
            foreach (UWWTD_DataUWWTD_ReportUWWTP uwwtp in uwwtps)
            {
                try
                {
                    if (lstUniqCodes.Contains(uwwtp.uwwCode))
                    {
                        logError("UWWTP " + uwwtp.uwwCode + " is not Unique");
                        reportFail();
                        continue;
                    }
                    lstUniqCodes.Add(uwwtp.uwwCode);
                    bool hasErrors = false;
                    for (int j = 0; j < uwwFldNames.Length; j++)
                    {
                        try
                        {
                            string modFieldName = uwwFldNames[j];
                            if (uwwFldNames[j].Equals("repCode") || uwwFldNames[j].Equals("exportDate")) continue;
                            if (modFieldName.IndexOf("Discharged")>0)
                                modFieldName = modFieldName.Replace("Discharged", "Discharge");
                            if (!checkQAACRule(uwwtp.GetType().GetField(modFieldName).GetValue(uwwtp), uwwFldNames[j], repPeriod, true, null))
                                hasErrors = true;
                        }
                        catch (Exception ex)
                        {
                            logError("Error in " + uwwFldNames[j] + ": " + ex.ToString());
                        }
                    }

                    int i = 0;
                    if (uwwtp.uwwState != null)
                        setParameterValue(cmd, i++, dataFactory.getLovRowByKey("STAT", uwwtp.uwwState)["lovID"]);
                    else
                        setParameterValue(cmd, i++, null);
                    setParameterValue(cmd, i++, repPeriod["repID"]);
                    parAgglo.Value = uwwtp.aggID;
                    if (uwwtp.aggID == null)
                        setParameterValue(cmd, i++, null);
                    else
                        setParameterValue(cmd, i++, cmdAgglo.ExecuteScalar());
                    setParameterValue(cmd, i++, uwwtp.uwwCode);
                    setParameterValue(cmd, i++, uwwtp.uwwName);
                    setParameterValue(cmd, i++, dataFactory.getLovRowByKey("UWWTP", uwwtp.uwwCollectingSystem)["lovID"]);
                    setParameterValue(cmd, i++, uwwtp.uwwDateClosing);
                    setParameterValue(cmd, i++, uwwtp.uwwHistorie);
                    if (uwwtp.uwwLatitudeSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwLatitude);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwLongitudeSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwLongitude);
                    else
                        setParameterValue(cmd, i++, null);
                    setParameterValue(cmd, i++, dataFactory.getNUTSIdForNUTSCode(uwwtp.uwwNUTS));
                    if (uwwtp.uwwLoadEnteringUWWTPSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwLoadEnteringUWWTP);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwCapacitySpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwCapacity);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwPrimaryTreatmentSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwPrimaryTreatment);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwSecondaryTreatmentSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwSecondaryTreatment);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwOtherTreatmentSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwOtherTreatment);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwNRemovalSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwNRemoval);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwPRemovalSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwPRemoval);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwUVSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwUV);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwChlorinationSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwChlorination);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwOzonationSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwOzonation);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwSandFiltrationSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwSandFiltration);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwMicroFiltrationSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwMicroFiltration);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwOtherSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwOther);
                    else
                        setParameterValue(cmd, i++, null);
                    setParameterValue(cmd, i++, uwwtp.uwwSpecification);
                    if (uwwtp.uwwBOD5Perf == null)
                        setParameterValue(cmd, i++, null);
                    else
                        setParameterValue(cmd, i++, dataFactory.getLovRowByKey("BOD5", uwwtp.uwwBOD5Perf)["lovID"]);
                    if (uwwtp.uwwCODPerf == null)
                        setParameterValue(cmd, i++, null);
                    else
                        setParameterValue(cmd, i++, dataFactory.getLovRowByKey("PASS", uwwtp.uwwCODPerf)["lovID"]);
                    if (uwwtp.uwwTSSPerf == null)
                        setParameterValue(cmd, i++, null);
                    else
                        setParameterValue(cmd, i++, dataFactory.getLovRowByKey("PASS", uwwtp.uwwTSSPerf)["lovID"]);
                    if (uwwtp.uwwNTotPerf == null)
                        setParameterValue(cmd, i++, null);
                    else
                        setParameterValue(cmd, i++, dataFactory.getLovRowByKey("PASS", uwwtp.uwwNTotPerf)["lovID"]);
                    if (uwwtp.uwwPTotPerf == null)
                        setParameterValue(cmd, i++, null);
                    else
                        setParameterValue(cmd, i++, dataFactory.getLovRowByKey("PASS", uwwtp.uwwPTotPerf)["lovID"]);
                    if (uwwtp.uwwOtherPerf == null)
                        setParameterValue(cmd, i++, null);
                    else
                        setParameterValue(cmd, i++, dataFactory.getLovRowByKey("PASS", uwwtp.uwwOtherPerf)["lovID"]);
                    if (uwwtp.uwwBadPerformanceSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwBadPerformance);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwAccidentsSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwAccidents);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwBadDesignSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwBadDesign);
                    else
                        setParameterValue(cmd, i++, null);
                    setParameterValue(cmd, i++, uwwtp.uwwInformation);
                    if (uwwtp.uwwBODIncomingMeasuredSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwBODIncomingMeasured);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwBODIncomingCalculatedSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwBODIncomingCalculated);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwBODIncomingEstimatedSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwBODIncomingEstimated);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwCODIncomingMeasuredSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwCODIncomingMeasured);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwCODIncomingCalculatedSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwCODIncomingCalculated);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwCODIncomingEstimatedSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwCODIncomingEstimated);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwNIncomingMeasuredSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwNIncomingMeasured);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwNIncomingCalculatedSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwNIncomingCalculated);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwNIncomingEstimatedSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwNIncomingEstimated);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwPIncomingMeasuredSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwPIncomingMeasured);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwPIncomingCalculatedSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwPIncomingCalculated);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwPIncomingEstimatedSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwPIncomingEstimated);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwBODDischargeMeasuredSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwBODDischargeMeasured);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwBODDischargeCalculatedSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwBODDischargeCalculated);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwBODDischargeEstimatedSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwBODDischargeEstimated);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwCODDischargeMeasuredSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwCODDischargeMeasured);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwCODDischargeCalculatedSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwCODDischargeCalculated);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwCODDischargeEstimatedSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwCODDischargeEstimated);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwNDischargeMeasuredSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwNDischargeMeasured);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwNDischargeCalculatedSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwNDischargeCalculated);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwNDischargeEstimatedSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwNDischargeEstimated);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwPDischargeMeasuredSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwPDischargeMeasured);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwPDischargeCalculatedSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwPDischargeCalculated);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwPDischargeEstimatedSpecified) 
                        setParameterValue(cmd, i++, uwwtp.uwwPDischargeEstimated);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwWasteWaterTreatedSpecified)
                        setParameterValue(cmd, i++, uwwtp.uwwWasteWaterTreated);
                    else
                        setParameterValue(cmd, i++, null);
                    if (uwwtp.uwwMethodWasteWaterTreated == null)
                        setParameterValue(cmd, i++, null);
                    else
                        setParameterValue(cmd, i++, dataFactory.getLovRowByKey("LOADDET", uwwtp.uwwMethodWasteWaterTreated)["lovID"]);
                    setParameterValue(cmd, i++, uwwtp.uwwRemarks);

                    cmd.ExecuteNonQuery();
                    if (hasErrors)
                        reportFail();
                    else
                        reportSuccess();
                }
                catch (Exception ex)
                {
                    logError("Exception: " + ex.Message + ";");
                    reportFail();
                }
            }
        }

        public override bool checkQAACRule(object value, string fieldName, DataRow repPeriod, bool isImport, string lineInfo)
        {
            bool retVal = true;
            string errorText = "";
            string infoText = "";

            switch (fieldName)
            {
                case "uwwState":
                    if (!checkFieldMandatoryPresence(value, fieldName, ref errorText))
                    {
                        retVal = false;
                        break;
                    }
                    if (value is string)
                    {
                        if (dataFactory.getLovRowByKey("STAT", value as string)["lovID"] is DBNull)
                        {
                            retVal = false;
                            errorText = fieldName + " not set to a correct value (" + value + ")";
                        }
                    }
                    else
                        if (!dataFactory.getLovRowByID(value)["lovName"].Equals("STAT"))
                        {
                            retVal = false;
                            errorText = fieldName + " not set to a correct value (" + value + ")";
                        }
                    break;
                case "uwwCode":
                    if (!checkFieldMandatoryPresence(value, fieldName, ref errorText))
                    {
                        retVal = false;
                        break;
                    }
                    string rptMemberState = repPeriod.GetParentRow("T_ReporterT_ReportPeriod").GetParentRow("T_Lov_T_Reporter")["lovKey"] as string;
                    if (!((value as string).StartsWith(rptMemberState)))
                    {
                        retVal = false;
                        errorText = fieldName + " (" + value + ") does not start with " + rptMemberState;
                        break;
                    }
                    break;
                //case "uwwName":
                //    if (!checkFieldMandatoryPresence(value, fieldName, ref errorText))
                //    {
                //        retVal = false;
                //        break;
                //    }
                //    break;
                case "uwwCollectingSystem":
                    if (!checkFieldMandatoryPresence(value, fieldName, ref errorText))
                    {
                        retVal = false;
                        break;
                    }
                    if (!checkLOVValue(value, fieldName, "UWWTP", ref errorText, isImport, null))
                    {
                        retVal = false;
                    }
                    break;
                case "uwwBOD5Perf":
                    if (!checkOptionalPresence(value, fieldName, ref errorText))
                    {
                        break;
                    }
                    if (!checkLOVValue(value, fieldName, "BOD5", ref errorText, isImport, null))
                    {
                        retVal = false;
                    }
                    break;
                case "uwwCODPerf":
                case "uwwTSSPerf":
                case "uwwNTotPerf":
                case "uwwPTotPerf":
                case "uwwOtherPerf":
                    if (!checkOptionalPresence(value, fieldName, ref errorText))
                    {
                        break;
                    }
                    if (!checkLOVValue(value, fieldName, "PASS", ref errorText, isImport, null))
                    {
                        retVal = false;
                    }
                    break;
                case "uwwLatitude":
                case "uwwLongitude":
                    checkOptionalPresence(value, fieldName, ref infoText);
                    break;
                default:
                    break;
            }

            if (!retVal)
            {
                if (lineInfo != null)
                {
                    errorText = lineInfo + " - " + errorText;
                }

                logError(errorText);
            }

            if (infoText.Length > 0) {
                if (lineInfo != null) {
                    infoText = lineInfo + " - " + infoText;
                }

                logInfo(infoText);
            }

            return retVal;
        }
    }
}
