﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using at.uba.uwwtd2008.Items;
using at.uba.uwwtd2008.DataAccess;
using System.Runtime.InteropServices;

namespace at.uba.uwwtd2008.Dialogs
{
    public partial class ImportExportSummary : Form
    {
        private LoggingClass usedLogger;

        public LoggingClass Logger
        {
            get { return usedLogger; }
            set { usedLogger = value; }
        }

        public ImportExportSummary()
        {
            InitializeComponent();
        }

        [DllImport("shell32.dll")]
        static extern IntPtr ShellExecute(
            IntPtr hwnd,
            string lpOperation,
            string lpFile,
            string lpParameters,
            string lpDirectory,
            int nShowCmd);

        private void OnViewLog(object sender, LinkLabelLinkClickedEventArgs e)
        {
            ShellExecute(this.Handle, "open", usedLogger.LogFileName, "", "", 4);
        }

        private void OnLoad(object sender, EventArgs e)
        {
            txtMSCount.Text = usedLogger.getCounter("Reporter").SuccessCount.ToString();
            txtRepCount.Text = usedLogger.getCounter("ReportPeriod").SuccessCount.ToString();
            txtContactValid.Text = usedLogger.getCounter("Contact").SuccessCount.ToString();
            txtContactInvalid.Text = usedLogger.getCounter("Contact").FailedCount.ToString();
            txtAgglomerationValid.Text = usedLogger.getCounter("Agglomerations").SuccessCount.ToString();
            txtAgglomerationInvalid.Text = usedLogger.getCounter("Agglomerations").FailedCount.ToString();
            txtDischargePointValid.Text = usedLogger.getCounter("DischargePoint").SuccessCount.ToString();
            txtDischargePointInvalid.Text = usedLogger.getCounter("DischargePoint").FailedCount.ToString();
            txtReceivingAreasValid.Text = usedLogger.getCounter("ReceivingAreas").SuccessCount.ToString();
            txtReceivingAreasInvalid.Text = usedLogger.getCounter("ReceivingAreas").FailedCount.ToString();
            txtUwwtpValid.Text = usedLogger.getCounter("UWWTP").SuccessCount.ToString();
            txtUwwtpInvalid.Text = usedLogger.getCounter("UWWTP").FailedCount.ToString();
            txtMemberStateValid.Text = usedLogger.getCounter("MemberState").SuccessCount.ToString();
            txtMemberStateInvalid.Text = usedLogger.getCounter("MemberState").FailedCount.ToString();

            DataAccessFactory dataAccess = DataAccessFactory.Instance;
            //get the counters for incorrect joined data
            using (IDbConnection conn = dataAccess.GetConnection()) {
                long lNotConnAgglos = 0;
                long lNoDPForUWWTD = 0;
                foreach (long reportPeriod in usedLogger.getReportPeriods()) {
                    object objNotConnAgglo = dataAccess.CreateCommand("SELECT COUNT(aggID) AS Expr1 FROM T_Agglomerations a "+ 
                        "WHERE (NOT EXISTS (SELECT aucID FROM T_Uwwtp_Agglo auc WHERE (a.aggID = aggID))) AND (NOT EXISTS "+
                        "(SELECT uwwID FROM T_UWWTPS uww WHERE (a.aggID = aggID))) AND repID = " + reportPeriod, conn).ExecuteScalar();
                    if (objNotConnAgglo is int) lNotConnAgglos += (int)objNotConnAgglo;
                    object objNoDPForUWWTD = dataAccess.CreateCommand("SELECT COUNT(uwwID) FROM T_UWWTPS u WHERE (NOT EXISTS "+
                        "(SELECT dcpID FROM T_DischargePoints d WHERE (u.uwwID = uwwID))) AND repID = " + reportPeriod, conn).ExecuteScalar();
                    if (objNoDPForUWWTD is int) lNoDPForUWWTD += (int)objNoDPForUWWTD;
                }
                txtAggloUwwtpInvalid.Text = lNotConnAgglos.ToString();
                txtUwwtpDPInvalid.Text = lNoDPForUWWTD.ToString();
            }
            txtCatchmentInvalid.Text = usedLogger.getCounter("RAWithoutCatchment").FailedCount.ToString();
        }

        private void OnClose(object sender, EventArgs e)
        {
            this.Visible = false;
            this.Dispose();
        }
    }
}
