﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using at.uba.uwwtd2008.DataAccess;

namespace at.uba.uwwtd2008.Items {
    class Contact {
        private const String selectString = "SELECT conID, repID, conCode, conName, conRemarks, conEmail, conPhone, conFax, " +
            "conCity, conZIP, conStreet, conInstitution FROM T_Contact";
        private static Dictionary<long, DataTable> dtTable=new Dictionary<long,DataTable>();

        private Contact() {
        }

        public static DataTable LoadTable(long repId, bool reload) {
            if (reload)
            {
                dtTable.Remove(repId);
            }

            if (!dtTable.ContainsKey(repId))
            {
                DataAccessFactory dataFactory = DataAccessFactory.Instance;
                IDbConnection conn = dataFactory.GetConnection();
                try
                {
                    IDbCommand cmd = dataFactory.CreateCommand(selectString+" WHERE repID = "+repId, conn);
                    dtTable[repId] = new DataTable("Contact");
                    IDataReader rdr = cmd.ExecuteReader();
                    try
                    {
                        dtTable[repId].Load(rdr);
                    }
                    finally
                    {
                        rdr.Close();
                    }
                }
                finally
                {
                    conn.Close();
                }              
            }
            return dtTable[repId];
        }        
    }
}
