﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using at.uba.uwwtd2008.DataAccess;

namespace at.uba.uwwtd2008.Items {
    public class ReportPeriod {
        private const String selectString = "SELECT repID, rptID, repCode, repVersion, repSituationAt, repReportedPeriod FROM T_ReportPeriod";

        private Reporter reporter;
        private long repID;
        private String repCode;
        private DateTime repVersion;
        private DateTime repSituationAt;
        private String repReportedPeriod;

        public long RepID {
            get { return repID; }
            set { repID = value; }
        }

        public String RepCode {
            get { return repCode; }
            set { repCode = value; }
        }

        public DateTime RepVersion {
            get { return repVersion; }
            set { repVersion = value; }
        }

        public DateTime RepSituationAt {
            get { return repSituationAt; }
            set { repSituationAt = value; }
        }

        public String RepReportedPeriod {
            get { return repReportedPeriod; }
            set { repReportedPeriod = value; }
        }

        private ReportPeriod() {
        }

        public Reporter Reporter {
            get { return reporter; }
            set { reporter = value; }
        }

        public static DataTable LoadReportPeriods(bool reLoad) {
            DataAccessFactory dataFactory = DataAccessFactory.Instance;
            if (reLoad) dataFactory.initReporters();

            return dataFactory.getReporterDataSet().Tables["T_ReportPeriod"];
        }

        public static ReportPeriod LoadReportPeriod(long repId) {
            DataTable table = LoadReportPeriods(false);
            DataRow [] rows = table.Select("repID = " + repId);
            if (rows.Length != 1) throw new ArgumentOutOfRangeException("ReporterPeriod for "+repId+" resulted in "+rows.Length+" rows ... should exactly be 1");

            ReportPeriod rep = new ReportPeriod();
            rep.loadFromRow(rows[0]);

            return rep;
        }

        private void loadFromRow(DataRow row) {
            object obj = row["rptID"];
            reporter = Reporter.CreateReporterFromRow(row.GetParentRow("T_ReporterT_ReportPeriod"));
            repID= long.Parse(row["repID"].ToString());
            repCode = row["repCode"] as String;
            if (row["repVersion"] is DBNull)
                repVersion = DateTime.MinValue;
            else
                repVersion = (DateTime)row["repVersion"];
            if (row["repSituationAt"] is DBNull)
                repSituationAt = DateTime.MinValue;
            else
                repSituationAt = (DateTime)row["repSituationAt"];
            repReportedPeriod = row["repReportedPeriod"] as String;
        }
    }
}
