﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using at.uba.uwwtd2008.DataAccess;
using System.ComponentModel;

namespace at.uba.uwwtd2008.Items {
    public class Reporter {
        private long rptId = -1;
        private State state;
        private String rptCulture;
        private long rptFormRA;

        private Reporter() {
        }

        public long RptId {
            get { return rptId; }
            set { rptId = value; }
        }

        public State State {
            get { return state; }
            set { state = value; }
        }
            

        public static DataTable LoadReporters(Boolean reLoad) {
            DataAccessFactory dataFactory = DataAccessFactory.Instance;
            if (reLoad) dataFactory.initReporters();

            return dataFactory.getReporterDataSet().Tables["T_Reporter"];
        }

        public static Reporter LoadReporter(long rptId) {
            DataTable data = LoadReporters(false);
            DataRow []rows = data.Select("rptID = " + rptId);
            if (rows.Length != 1) throw new ArgumentOutOfRangeException("Reporter loading with rptId = "+rptId+" resulted in "+rows.Length+" results ... should exactl be 1");
            Reporter reporter = new Reporter();
            reporter.LoadFromDataRow(rows[0]);

            return reporter;
        }

        public static Reporter CreateReporterFromRow(DataRow row)
        {
            Reporter reporter = new Reporter();
            reporter.LoadFromDataRow(row);
            return reporter;
        }

        private void LoadFromDataRow(DataRow row) {
            rptId = long.Parse(row["rptId"].ToString());
            state = State.getStateById(long.Parse(row["rptMState"].ToString()));
            rptCulture = row["rptCulture"] as String;
            if (row["rptFormRA"] is DBNull)
                rptFormRA = -1;
            else
                rptFormRA = long.Parse(row["rptFormRA"].ToString());
        }

        public void setCurrentMemberstate(String mStateKey) {
            DataTable dt = State.getAllStates();
            DataRow [] rows = dt.Select("lovKey = '" + mStateKey + "'");
            if (rows.Length != 1) throw new ArgumentOutOfRangeException("The memberstate-key " + mStateKey + " resulted in " + rows.Length + " Values - should be one value");

            state = State.getStateById((long) rows[0]["lovId"]);
        }
    }
}
