﻿using System;
using System.Collections.Generic;
using System.Text;
using at.uba.uwwtd2008.DataAccess;
using System.Data;

namespace at.uba.uwwtd2008.Items {
    
    public class State {
        private static DataTable dt = null;
        long id;
        String key, val;

        private State() {
        }

        public long Id {
            get { return id; }
            set { id = value; }
        }

        public String Key {
            get { return key; }
            set { key=value; }
        }

        public String Value {
            get { return val; }
            set { val = value; }
        }

        public static State getStateById(long id) {
            DataTable data = getAllStates();
            DataRow[] rows = data.Select("lovId = " + id);
            if (rows.Length != 1) throw new ArgumentOutOfRangeException("State for id " + id + " resulted in " + rows.Length + " results - should be exactly 1");
            State state = new State();
            state.ReadFromRow(rows[0]);
            return state;
        }

        private void ReadFromRow(DataRow row) {
            Id = System.Int64.Parse((string) row["lovId"]);
            Key = (String) row["lovKey"];
            Value = (String) row["lovWert"];
        }

        public static DataTable getAllStates() {
            if (dt == null)
            {
                DataAccessFactory dataFactory = DataAccessFactory.Instance;
                IDbConnection conn = dataFactory.GetConnection();
                try
                {
                    IDbCommand cmd = dataFactory.CreateCommand("Select lovWert, lovId, lovKey from T_LOV where lovName='MS'", conn);
                    dt = new DataTable();
                    //DataSet ds = new DataSet();
                    //mDataFactory.CreateDataAdapter(cmd).Fill(ds);

                    dt.Columns.Add("lovWert", typeof(System.String));
                    dt.Columns.Add("lovKey", typeof(System.String));
                    dt.Columns.Add("lovId", typeof(System.String));

                    IDataReader rdr = cmd.ExecuteReader();
                    try
                    {
                        while (rdr.Read())
                        {
                            DataRow row = dt.NewRow();
                            row["lovWert"] = rdr["lovWert"];
                            row["lovId"] = rdr["lovId"];
                            row["lovKey"] = rdr["lovKey"];
                            dt.Rows.Add(row);
                        }
                    }
                    finally
                    {
                        rdr.Close();
                    }
                }
                finally
                {
                    conn.Close();
                }
            }

            return dt;
        }
    }
}
