using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using at.uba.uwwtd2008.components;

namespace at.uba.uwwtd2008
{
    public partial class UWWTD2008MainForm : Form
    {
        public static Color COLOR_FIELD_MANDATORY = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(255)))), ((int)(((byte)(128)))));
        public static Color COLOR_FIELD_NORMAL = System.Drawing.SystemColors.Window;
        public static Color COLOR_FIELD_ERROR = System.Drawing.Color.Red;

        private static UWWTD2008MainForm instance = null;

        public UWWTD2008MainForm()
        {
            instance = this;
            InitializeComponent();
        }

        public static UWWTD2008MainForm Instance
        {
            get { return instance; }
        }

        public void ExitApplication(object sender)
        {
            this.Close();
        }

        public void RepositionContent()
        {
            if (PanelMain.Controls.Count <= 0) return; // nothing to do in that case
            Control ctrl = PanelMain.Controls[0];
            if (ctrl == ctrlSplitterPanel)
            {
                return;
            }
            int xpos = (PanelMain.Width - ctrl.Width) / 2;
            int ypos = (PanelMain.Height - ctrl.Height) / 2;
            if (xpos < 0) xpos = 0;
            if (ypos < 0) ypos = 0;
            ctrl.Left = xpos;
            ctrl.Top = ypos;
        }

        public static UWWTD2008MainForm getMainForm(Control ctrl)
        {
            Control c = ctrl;
            while (c != null)
            {
                if (c is UWWTD2008MainForm) return ((UWWTD2008MainForm)c);
                c = c.Parent;
            }

            return null;
        }

        public components.CtrlSplitterPanel getSplitterPanel()
        {
            return this.ctrlSplitterPanel;
        }

        public void OpenOpenerWindow()
        {
            if (PanelMain.Controls[0] == ctrlOpenerWindow1) return; // Control already open
            PanelMain.Controls.Clear();
            PanelMain.Controls.Add(ctrlOpenerWindow1);
            RepositionContent();
            this.toolStatusLabel.Text = "UWWTD Main Window";
        }

        public void OpenDataEditMain()
        {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.setContentPane(ctrlDataEditMain);
        }

        public void OpenReporterEdit()
        {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            CtrlReporterEdit reporterEdit = new CtrlReporterEdit();
            reporterEdit.Name = "Country and Contact Details";

            ctrlSplitterPanel.setContentPane(reporterEdit);
        }

        public void OpenReceivingAreaEdit()
        {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.OpenReceivingAreasEdit();
        }

        public void OpenAgglomerationsEdit()
        {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.OpenAgglomerationsEdit();
        }

        public void OpenMemberStateLevelEdit()
        {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.OpenMemberStateLevelEdit();
        }

        public void OpenUWWTDEdit(UWWTDBaseCtrl predecessor) {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.OpenUWWTDEdit(predecessor);
        }

        public void OpenTreatment(UWWTDBaseCtrl predecessor)
        {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.OpenTreatment(predecessor);
        }

        public void OpenLoadsTreated(UWWTDBaseCtrl predecessor)
        {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.OpenLoadsTreated(predecessor);
        }

        public void OpenDischargePointsEdit(UWWTDBaseCtrl predecessor)
        {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.OpenDischargePointsEdit(predecessor);
        }

        public void OpenRaArt23Edit(UWWTDBaseCtrl predecessor)
        {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.OpenRaArt23Edit(predecessor);
        }

        public void OpenSAEdit(UWWTDBaseCtrl predecessor)
        {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.OpenSAEdit(predecessor);
        }

        public void OpenRa54Edit(UWWTDBaseCtrl predecessor)
        {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.OpenRa54Edit(predecessor);
        }

        public void OpenLSAEdit(UWWTDBaseCtrl predecessor)
        {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.OpenLSAEdit(predecessor);
        }

        public void OpenRaArt5854Edit(UWWTDBaseCtrl predecessor)
        {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.OpenRaArt5854Edit(predecessor);
        }

        public void OpenDPWithoutTreatment(UWWTDBaseCtrl predecessor)
        {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.OpenDPWithoutTreatmentEdit(predecessor);
        }

        public void OpenEditBigCity(UWWTDBaseCtrl predecessor)
        {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.OpenEditBigCity(predecessor);
        }

        public void OpenEditIndustry(UWWTDBaseCtrl predecessor)
        {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.OpenEditIndustry(predecessor);
        }

        public void OpenEditCollection(UWWTDBaseCtrl predecessor)
        {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.OpenEditCollection(predecessor);
        }

        public void OpenEditIAS(UWWTDBaseCtrl predecessor)
        {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.OpenEditIAS(predecessor);
        }

        public void OpenEditLeaksAndStormWater(UWWTDBaseCtrl predecessor)
        {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.OpenEditLeaksStormWater(predecessor);
        }

        public void OpenManageFiles(UWWTDBaseCtrl parent)
        {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.OpenFileControl(parent);
        }

        public void OpenArt17Data(UWWTDBaseCtrl parent) {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.OpenArt17Data(parent);
        }

        public void OpenSituationReport(UWWTDBaseCtrl parent)
        {
            if (PanelMain.Controls[0] != ctrlSplitterPanel)
            {
                PanelMain.Controls.Clear();
                PanelMain.Controls.Add(ctrlSplitterPanel);
            }

            ctrlSplitterPanel.OpenSituationReport(parent);
        }

        public void setStatusText(string strText)
        {
            this.toolStatusLabel.Text = strText;
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExitApplication(sender);
        }

        private void OnResizeDrawingArea(object sender, EventArgs e)
        {
            if (sender == PanelMain)
            {
                RepositionContent();
            }
        }

        private void OnAbout(object sender, EventArgs e)
        {
            UWWTDAbout about = new UWWTDAbout();
            about.ShowDialog();
        }

        private void OnDataCollectionClicked(object sender, EventArgs e)
        {
            OpenDataEditMain();
        }

        private void OnMainWindowOpen(object sender, EventArgs e)
        {
            OpenOpenerWindow();
        }

        private void OnEditReporterClicked(object sender, EventArgs e)
        {
            OpenReporterEdit();
        }

        private void ctrlOpenerWindow1_Load(object sender, EventArgs e)
        {

        }

    }
}