using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using at.uba.uwwtd2008.Dialogs;

namespace at.uba.uwwtd2008.components
{
    public partial class CtrlDataEditMain : UWWTDBaseCtrl
    {
        public CtrlDataEditMain()
        {
            InitializeComponent();
        }

        private void OnLinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            MessageBox.Show("LinkClicked");
        }

        private void OnReceivingAreaEditClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            ((UWWTD2008MainForm)(this.Parent.Parent.Parent.Parent)).OpenReceivingAreaEdit();
        }

        private void OnAgglomerationsEditClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            ((UWWTD2008MainForm)(this.Parent.Parent.Parent.Parent)).OpenAgglomerationsEdit();
        }

        private void OnMemberStateLevelEditClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            ((UWWTD2008MainForm)(this.Parent.Parent.Parent.Parent)).OpenMemberStateLevelEdit();
        }

        public override void OnBackButtonClick()
        {
            UWWTD2008MainForm mf = UWWTD2008MainForm.getMainForm(this);
            if (mf != null) mf.OpenOpenerWindow();
        }

        private void OnXMLExport(object sender, LinkLabelLinkClickedEventArgs e)
        {
            XMLExportDialog dlg = new XMLExportDialog();
            dlg.ShowDialog(this);
        }

        private void OnXMLImport(object sender, LinkLabelLinkClickedEventArgs e)
        {
            XMLImportDialog dlg = new XMLImportDialog();
            dlg.ShowDialog(this);

            // Refresh all Data to reflect changes
            mDataFactory.initReporters();
            mDataFactory.setCurrentReportPeriod(CurrentRep);
        }

        private void OnImplementationProgramme(object sender, LinkLabelLinkClickedEventArgs e) {
            UWWTD2008MainForm.getMainForm(this).OpenArt17Data(null);
        }

        private void OnOpenSituationReport(object sender, LinkLabelLinkClickedEventArgs e)
        {
            UWWTD2008MainForm.getMainForm(this).OpenSituationReport(null);
        }

        private void OnCSVImport(object sender, LinkLabelLinkClickedEventArgs e) {
            CSVImportDialog dlg = new CSVImportDialog();
            dlg.ShowDialog(this);

            // Refresh all Data to reflect changes
            mDataFactory.initReporters();
            mDataFactory.setCurrentReportPeriod(CurrentRep);
        }

        private void OnCSVExport(object sender, LinkLabelLinkClickedEventArgs e) {
            CSVExportDialog dlg = new CSVExportDialog();
            dlg.ShowDialog(this);
        }
    }
}
