﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace at.uba.uwwtd2008.components {
    public partial class CtrlLeaksStormWaterEdit : UWWTDBaseCtrl {
        private DataSet dataSet;
        public const String TNAME_AGGLO = CtrlAgglomerationsEdit.TNAME_AGGLO;
        
        public CtrlLeaksStormWaterEdit()
        {
            InitializeComponent();
        }

        public override void OnBackButtonClick()
        {
            UWWTD2008MainForm mf = UWWTD2008MainForm.getMainForm(this);
            if (mf == null) return;

            if (BindingContext[dataSet, CtrlAgglomerationsEdit.TNAME_AGGLO].Position >= 0)
            {
                DataRowView row = BindingContext[dataSet, CtrlAgglomerationsEdit.TNAME_AGGLO].Current as DataRowView;
                if (row != null) row.CancelEdit();
            }

            if (PrevControl != null) mf.getSplitterPanel().setContentPane(PrevControl);
            else mf.OpenDataEditMain();
        }

        public override void OpenForm()
        {
            this.BindingContext[dataSet, CtrlAgglomerationsEdit.TNAME_AGGLO].Position = ((CtrlCollectionEdit)PrevControl).BindingContext[dataSet, CtrlAgglomerationsEdit.TNAME_AGGLO].Position;
            // check, what to do in here
            if (BindingContext[dataSet, CtrlAgglomerationsEdit.TNAME_AGGLO].Position >= 0)
            {
                DataRowView row = BindingContext[dataSet, CtrlAgglomerationsEdit.TNAME_AGGLO].Current as DataRowView;
                if (row != null) row.BeginEdit();
            }
        }

        public override void PerformDataBinding(DataSet dataSet)
        {
            this.dataSet = dataSet;

            cmbExistMaintenancePlan.DataBindings.Clear();
            cmbExistMaintenancePlan.DataSource = mDataFactory.getYNLovValues();
            cmbExistMaintenancePlan.DisplayMember = "lovWert";
            cmbExistMaintenancePlan.ValueMember = "lovID";
            cmbExistMaintenancePlan.DataBindings.Add("SelectedValue", dataSet, TNAME_AGGLO + ".aggExistMaintenancePlan");

            cmbHaveRegistrationSystem.DataBindings.Clear();
            cmbHaveRegistrationSystem.DataSource = mDataFactory.getYNLovValues();
            cmbHaveRegistrationSystem.DisplayMember = "lovWert";
            cmbHaveRegistrationSystem.ValueMember = "lovID";
            cmbHaveRegistrationSystem.DataBindings.Add("SelectedValue", dataSet, TNAME_AGGLO + ".aggHaveRegistrationSystem");

            cmbBestTechnicalKnowledge.DataBindings.Clear();
            cmbBestTechnicalKnowledge.DisplayMember = "lovWert";
            cmbBestTechnicalKnowledge.ValueMember = "lovID";
            cmbBestTechnicalKnowledge.DataSource = mDataFactory.getYNLovValues();
            cmbBestTechnicalKnowledge.DataBindings.Add("SelectedValue", dataSet, TNAME_AGGLO + ".aggBestTechnicalKnowledge");

            DataView viewSewanet = mDataFactory.getLovViewByKey("SEWANET");
            viewSewanet.Sort = "lovWert";
            cmbSewageNetwork.DataBindings.Clear();
            cmbSewageNetwork.DisplayMember = "lovWert";
            cmbSewageNetwork.ValueMember = "lovID";
            cmbSewageNetwork.DataSource = viewSewanet;
            cmbSewageNetwork.DataBindings.Add("SelectedValue", dataSet, TNAME_AGGLO + ".aggSewageNetwork");

            txtExplanationOther.DataBindings.Clear();
            txtExplanationOther.DataBindings.Add("Text", dataSet, TNAME_AGGLO + ".aggExplanationOther", true, DataSourceUpdateMode.OnValidation, "");

            ckbAccOverflows.DataBindings.Clear();
            ckbAccOverflows.DataBindings.Add("Checked", dataSet, TNAME_AGGLO + ".aggAccOverflows", true, DataSourceUpdateMode.OnValidation, false);

            txtAccOverflowNumber.DataBindings.Clear();
            txtAccOverflowNumber.DataBindings.Add("Text", dataSet, TNAME_AGGLO + ".aggAccOverflowNumber", true, DataSourceUpdateMode.OnValidation, "");

            ckbCapacity.DataBindings.Clear();
            ckbCapacity.DataBindings.Add("Checked", dataSet, TNAME_AGGLO + ".aggCapacity", true, DataSourceUpdateMode.OnValidation, false);

            ckbDilutionRates.DataBindings.Clear();
            ckbDilutionRates.DataBindings.Add("Checked", dataSet, TNAME_AGGLO + ".aggDilutionRates", true, DataSourceUpdateMode.OnValidation, false);

            ckbOtherMeasures.DataBindings.Clear();
            ckbOtherMeasures.DataBindings.Add("Checked", dataSet, TNAME_AGGLO + ".aggOtherMeasures", true, DataSourceUpdateMode.OnValidation, false);

            ckbPressureTest.DataBindings.Clear();
            ckbPressureTest.DataBindings.Add("Checked", dataSet, TNAME_AGGLO + ".aggPressureTest", true, DataSourceUpdateMode.OnValidation, false);

            ckbVideoInspections.DataBindings.Clear();
            ckbVideoInspections.DataBindings.Add("Checked", dataSet, TNAME_AGGLO + ".aggVideoInspections", true, DataSourceUpdateMode.OnValidation, false);

            txtSewerOverflows_m3.DataBindings.Clear();
            txtSewerOverflows_m3.DataBindings.Add("Text", dataSet, TNAME_AGGLO + ".aggSewerOverflows_m3", true, DataSourceUpdateMode.OnValidation, "");

            txtSewerOverflows_pe.DataBindings.Clear();
            txtSewerOverflows_pe.DataBindings.Add("Text", dataSet, TNAME_AGGLO + ".aggSewerOverflows_pe", true, DataSourceUpdateMode.OnValidation, "");
        }

        private void OnSaveLeaks(object sender, LinkLabelLinkClickedEventArgs e)
        {
            DataRowView row = BindingContext[dataSet, CtrlAgglomerationsEdit.TNAME_AGGLO].Current as DataRowView;
            if (row != null)
            {
                row.EndEdit();
            }
            string errorText = "";
            if ((e != null) && (!ValidateForm(ref errorText, row != null ? row.Row.RowState : DataRowState.Detached))) {
                MessageBox.Show(this, "Please correct Form Errors before save:\r\n" + errorText, "Form not valid", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                return;
            }
            
            if (dataSet.HasChanges())
            {
                IDbConnection conn = mDataFactory.GetConnection();
                try
                {
                    bool enforceConstraints = dataSet.EnforceConstraints;
                    dataSet.EnforceConstraints = false;
                    try
                    {
                        int curPos = BindingContext[dataSet, TNAME_AGGLO].Position;
                        IDbCommand cmd = mDataFactory.CreateCommand(CtrlAgglomerationsEdit.SelectString + CurrentRep.RepID, conn);
                        IDbDataAdapter adapter = mDataFactory.CreateFullDataAdapter(cmd);
                        mDataFactory.UpdateDataAdapter(adapter, dataSet, TNAME_AGGLO);
                        mDataFactory.FillDataAdapter(adapter, dataSet, TNAME_AGGLO);
                        if (BindingContext[dataSet, TNAME_AGGLO].Count > curPos)
                        {
                            BindingContext[dataSet, TNAME_AGGLO].Position = curPos;
                            UWWTDBaseCtrl ctrl = this;
                            while (ctrl.PrevControl != null) ctrl = ctrl.PrevControl;
                            ctrl.BindingContext[dataSet, TNAME_AGGLO].Position = curPos; // re-set the position in the Agglomeration-Form
                        }
                        // now: store the aucPercC2T
                        cmd = mDataFactory.CreateCommand("Select * FROM T_UWWTP_AGGLO WHERE repID = " + CurrentRep.RepID, conn);
                        adapter = mDataFactory.CreateFullDataAdapter(cmd);
                        mDataFactory.UpdateDataAdapter(adapter, dataSet, CtrlCollectionEdit.TNAME_UWWAGGLO);
                    }
                    finally
                    {
                        dataSet.EnforceConstraints = enforceConstraints;
                    }
                }
                finally
                {
                    conn.Close();
                }
            }
            row = BindingContext[dataSet, CtrlAgglomerationsEdit.TNAME_AGGLO].Current as DataRowView;
            if (row != null) row.BeginEdit();

            if (e != null) {
                ShowSaveConfirmation();
            }
        }

        private void OnDelete(object sender, LinkLabelLinkClickedEventArgs e)
        {
            if (ShowConfirmDelete()) {
                DataRowView row = BindingContext[dataSet, CtrlAgglomerationsEdit.TNAME_AGGLO].Current as DataRowView;
                if (row != null) {
                    row["aggExistMaintenancePlan"] = dataSet.Tables[TNAME_AGGLO].Columns["aggExistMaintenancePlan"].DefaultValue;
                    row["aggHaveRegistrationSystem"] = dataSet.Tables[TNAME_AGGLO].Columns["aggHaveRegistrationSystem"].DefaultValue;
                    row["aggBestTechnicalKnowledge"] = dataSet.Tables[TNAME_AGGLO].Columns["aggBestTechnicalKnowledge"].DefaultValue;
                    row["aggSewageNetwork"] = dataSet.Tables[TNAME_AGGLO].Columns["aggSewageNetwork"].DefaultValue;
                    row["aggExplanationOther"] = dataSet.Tables[TNAME_AGGLO].Columns["aggExplanationOther"].DefaultValue;
                    row["aggAccOverflows"] = dataSet.Tables[TNAME_AGGLO].Columns["aggAccOverflows"].DefaultValue;
                    row["aggCapacity"] = dataSet.Tables[TNAME_AGGLO].Columns["aggCapacity"].DefaultValue;
                    row["aggDilutionRates"] = dataSet.Tables[TNAME_AGGLO].Columns["aggDilutionRates"].DefaultValue;
                    row["aggOtherMeasures"] = dataSet.Tables[TNAME_AGGLO].Columns["aggOtherMeasures"].DefaultValue;
                    row["aggPressureTest"] = dataSet.Tables[TNAME_AGGLO].Columns["aggPressureTest"].DefaultValue;
                    row["aggVideoInspections"] = dataSet.Tables[TNAME_AGGLO].Columns["aggVideoInspections"].DefaultValue;
                    row["aggSewerOverflows_m3"] = dataSet.Tables[TNAME_AGGLO].Columns["aggSewerOverflows_m3"].DefaultValue;
                    row["aggSewerOverflows_pe"] = dataSet.Tables[TNAME_AGGLO].Columns["aggSewerOverflows_pe"].DefaultValue;
                    row.EndEdit();
                }

                if (dataSet.HasChanges()) {
                    OnSaveLeaks(sender, null);
                    //IDbConnection conn = mDataFactory.GetConnection();
                    //try
                    //{
                    //    bool enforceConstraints = dataSet.EnforceConstraints;
                    //    dataSet.EnforceConstraints = false;
                    //    try
                    //    {
                    //        int curPos = BindingContext[dataSet, TNAME_AGGLO].Position;
                    //        IDbCommand cmd = mDataFactory.CreateCommand(CtrlAgglomerationsEdit.SelectString + CurrentRep.RepID, conn);
                    //        IDbDataAdapter adapter = mDataFactory.CreateFullDataAdapter(cmd);
                    //        mDataFactory.UpdateDataAdapter(adapter, dataSet, TNAME_AGGLO);
                    //        mDataFactory.FillDataAdapter(adapter, dataSet, TNAME_AGGLO);
                    //        if (BindingContext[dataSet, TNAME_AGGLO].Count > curPos)
                    //        {
                    //            BindingContext[dataSet, TNAME_AGGLO].Position = curPos;
                    //        }
                    //        // now: store the aucPercC2T
                    //        cmd = mDataFactory.CreateCommand("Select * FROM T_UWWTP_AGGLO WHERE repID = " + CurrentRep.RepID, conn);
                    //        adapter = mDataFactory.CreateFullDataAdapter(cmd);
                    //        mDataFactory.UpdateDataAdapter(adapter, dataSet, CtrlCollectionEdit.TNAME_UWWAGGLO);
                    //    }
                    //    finally
                    //    {
                    //        dataSet.EnforceConstraints = enforceConstraints;
                    //    }
                    //}
                    //finally
                    //{
                    //    conn.Close();
                    //}
                }
                //row = BindingContext[dataSet, CtrlAgglomerationsEdit.TNAME_AGGLO].Current as DataRowView;
                //if (row != null) row.BeginEdit();
            }
        }

        private void OnSewanetChanged(object sender, EventArgs e)
        {
            bool showAdditionalFields = false;
            object obj = cmbSewageNetwork.SelectedValue;
            if ((obj == null) || (obj is DBNull))
            {
                showAdditionalFields = false;
            }
            else
            {
                string strLov = mDataFactory.getLovRowByID(obj)["lovKey"] as string;
                if (strLov == null)
                    showAdditionalFields = false;
                else
                {
                    switch (strLov)
                    {
                        case "B":
                        case "C":
                            showAdditionalFields = true;
                            break;
                        case "S":
                            showAdditionalFields = false;
                            break;
                        default:
                            showAdditionalFields = false;
                            break;
                    }
                }
            }

            if (!showAdditionalFields)
            {
                lblSewerOverflows_m3.Visible = false;
                lblSewerOverflows_pe.Visible = false;
                txtSewerOverflows_m3.Visible = false;
                txtSewerOverflows_pe.Visible = false;
                cmbBestTechnicalKnowledge.Visible = false;
                lblBestTechnicalKnowledge.Visible = false;
            }
            else
            {
                lblSewerOverflows_m3.Visible = true;
                lblSewerOverflows_pe.Visible = true;
                txtSewerOverflows_m3.Visible = true;
                txtSewerOverflows_pe.Visible = true;
                cmbBestTechnicalKnowledge.Visible = true;
                lblBestTechnicalKnowledge.Visible = true;
            }

        }

        private void OnBestTechKnowlegeChanged(object sender, EventArgs e)
        {
            bool showAdditionalFields = cmbBestTechnicalKnowledge.Visible;
            object obj = cmbBestTechnicalKnowledge.SelectedValue;
            if ((obj == null) || (obj is DBNull))
            {
                showAdditionalFields = false;
            }
            else
            {
                string strLov = mDataFactory.getLovRowByID(obj)["lovKey"] as string;
                if (strLov == null)
                    showAdditionalFields = false;
                else
                {
                    switch (strLov)
                    {
                        case "1":
                            showAdditionalFields = true;
                            break;
                        case "0":
                            showAdditionalFields = false;
                            break;
                        default:
                            showAdditionalFields = false;
                            break;
                    }
                }
            }

            if (!showAdditionalFields)
            {
                groupDetails.Visible = false;
            }
            else
            {
                groupDetails.Visible = true;
            }

        }
    }
}
