﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace at.uba.uwwtd2008.components {
    public partial class CtrlLoadsTreated : UWWTDBaseCtrl {
        private DataSet dataSet;
        private const String TNAME_UWWTDS = CtrlUWWTDEdit.TNAME_UWWTDS; // only to shorten typing

        public CtrlLoadsTreated() {
            InitializeComponent();
        }

        public override void OnBackButtonClick() {
            UWWTD2008MainForm mf = UWWTD2008MainForm.getMainForm(this);
            if (mf == null) return;

            if (BindingContext[dataSet, TNAME_UWWTDS].Position >= 0)
            {
                DataRowView row = BindingContext[dataSet, TNAME_UWWTDS].Current as DataRowView;
                if (row != null) row.CancelEdit();
            }

            if (PrevControl != null) mf.getSplitterPanel().setContentPane(PrevControl);
            else mf.OpenDataEditMain();
        }

        public override void OpenForm()
        {
            this.BindingContext[dataSet, CtrlAgglomerationsEdit.TNAME_AGGLO].Position = PrevControl.BindingContext[dataSet, CtrlAgglomerationsEdit.TNAME_AGGLO].Position;
            this.BindingContext[dataSet, CtrlUWWTDEdit.TNAME_UWWTDS].Position = PrevControl.BindingContext[dataSet, CtrlUWWTDEdit.TNAME_UWWTDS].Position;
            
            if (BindingContext[dataSet, TNAME_UWWTDS].Position >= 0)
            {
                DataRowView row = BindingContext[dataSet, TNAME_UWWTDS].Current as DataRowView;
                if (row != null) row.BeginEdit();
            }
            else
            {
                MessageBox.Show(this, "Please select a valid UWWTP to open this Form", "No UWWTP selected", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            	  OnBackButtonClick();
            	  return;
            }

            BODIncomingRowChanged(null, null);
            CODIncomingRowChanged(null, null);
            PIncomingRowChanged(null, null);
            NIncomingRowChanged(null, null);
            BODDischargedRowChanged(null, null);
            CODDischargedRowChanged(null, null);
            PDischargedRowChanged(null, null);
            NDischargedRowChanged(null, null);
        }

        public override void PerformDataBinding(DataSet dataSet)
        {
            this.dataSet = dataSet;

            txtUwwCode.DataBindings.Clear();
            txtUwwCode.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwCode");
            txtUwwName.DataBindings.Clear();
            txtUwwName.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwName");
            txtWasteWaterTreated.DataBindings.Clear();
            txtWasteWaterTreated.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwWasteWaterTreated");
            cmbMethodWasteWaterTreated.DataBindings.Clear();
            cmbMethodWasteWaterTreated.DataSource = mDataFactory.getLOADDETValues();
            cmbMethodWasteWaterTreated.DisplayMember = "lovWert";
            cmbMethodWasteWaterTreated.ValueMember = "lovID";
            cmbMethodWasteWaterTreated.DataBindings.Add("SelectedValue", dataSet, TNAME_UWWTDS + ".uwwMethodWasteWaterTreated");

            txtBODIncomingMeasured.DataBindings.Clear();
            txtCODIncomingMeasured.DataBindings.Clear();
            txtNIncomingMeasured.DataBindings.Clear();
            txtPIncomingMeasured.DataBindings.Clear();
            txtBODIncomingCalculated.DataBindings.Clear();
            txtCODIncomingCalculated.DataBindings.Clear();
            txtNIncomingCalculated.DataBindings.Clear();
            txtPIncomingCalculated.DataBindings.Clear();
            txtBODIncomingEstimated.DataBindings.Clear();
            txtCODIncomingEstimated.DataBindings.Clear();
            txtNIncomingEstimated.DataBindings.Clear();
            txtPIncomingEstimated.DataBindings.Clear();

            txtBODIncomingMeasured.TextChanged += new EventHandler(BODIncomingRowChanged);
            txtCODIncomingMeasured.TextChanged += new EventHandler(CODIncomingRowChanged);
            txtNIncomingMeasured.TextChanged += new EventHandler(NIncomingRowChanged);
            txtPIncomingMeasured.TextChanged += new EventHandler(PIncomingRowChanged);
            txtBODIncomingEstimated.TextChanged += new EventHandler(BODIncomingRowChanged);
            txtCODIncomingEstimated.TextChanged += new EventHandler(CODIncomingRowChanged);
            txtNIncomingEstimated.TextChanged += new EventHandler(NIncomingRowChanged);
            txtPIncomingEstimated.TextChanged += new EventHandler(PIncomingRowChanged);
            txtBODIncomingCalculated.TextChanged += new EventHandler(BODIncomingRowChanged);
            txtCODIncomingCalculated.TextChanged += new EventHandler(CODIncomingRowChanged);
            txtNIncomingCalculated.TextChanged += new EventHandler(NIncomingRowChanged);
            txtPIncomingCalculated.TextChanged += new EventHandler(PIncomingRowChanged);

            txtBODIncomingMeasured.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwBODIncomingMeasured", true, DataSourceUpdateMode.OnValidation, "");
            txtCODIncomingMeasured.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwCODIncomingMeasured", true, DataSourceUpdateMode.OnValidation, "");
            txtNIncomingMeasured.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwNIncomingMeasured", true, DataSourceUpdateMode.OnValidation, "");
            txtPIncomingMeasured.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwPIncomingMeasured", true, DataSourceUpdateMode.OnValidation, "");
            txtBODIncomingCalculated.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwBODIncomingCalculated", true, DataSourceUpdateMode.OnValidation, "");
            txtCODIncomingCalculated.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwCODIncomingCalculated", true, DataSourceUpdateMode.OnValidation, "");
            txtNIncomingCalculated.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwNIncomingCalculated", true, DataSourceUpdateMode.OnValidation, "");
            txtPIncomingCalculated.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwPIncomingCalculated", true, DataSourceUpdateMode.OnValidation, "");
            txtBODIncomingEstimated.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwBODIncomingEstimated", true, DataSourceUpdateMode.OnValidation, "");
            txtCODIncomingEstimated.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwCODIncomingEstimated", true, DataSourceUpdateMode.OnValidation, "");
            txtNIncomingEstimated.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwNIncomingEstimated", true, DataSourceUpdateMode.OnValidation, "");
            txtPIncomingEstimated.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwPIncomingEstimated", true, DataSourceUpdateMode.OnValidation, "");

            txtBODDischargedMeasured.DataBindings.Clear();
            txtCODDischargedMeasured.DataBindings.Clear();
            txtNDischargedMeasured.DataBindings.Clear();
            txtPDischargedMeasured.DataBindings.Clear();
            txtBODDischargedCalculated.DataBindings.Clear();
            txtCODDischargedCalculated.DataBindings.Clear();
            txtNDischargedCalculated.DataBindings.Clear();
            txtPDischargedCalculated.DataBindings.Clear();
            txtBODDischargedEstimated.DataBindings.Clear();
            txtCODDischargedEstimated.DataBindings.Clear();
            txtNDischargedEstimated.DataBindings.Clear();
            txtPDischargedEstimated.DataBindings.Clear();

            txtBODDischargedMeasured.TextChanged += new EventHandler(BODDischargedRowChanged);
            txtCODDischargedMeasured.TextChanged += new EventHandler(CODDischargedRowChanged);
            txtNDischargedMeasured.TextChanged += new EventHandler(NDischargedRowChanged);
            txtPDischargedMeasured.TextChanged += new EventHandler(PDischargedRowChanged);
            txtBODDischargedEstimated.TextChanged += new EventHandler(BODDischargedRowChanged);
            txtCODDischargedEstimated.TextChanged += new EventHandler(CODDischargedRowChanged);
            txtNDischargedEstimated.TextChanged += new EventHandler(NDischargedRowChanged);
            txtPDischargedEstimated.TextChanged += new EventHandler(PDischargedRowChanged);
            txtBODDischargedCalculated.TextChanged += new EventHandler(BODDischargedRowChanged);
            txtCODDischargedCalculated.TextChanged += new EventHandler(CODDischargedRowChanged);
            txtNDischargedCalculated.TextChanged += new EventHandler(NDischargedRowChanged);
            txtPDischargedCalculated.TextChanged += new EventHandler(PDischargedRowChanged);

            txtBODDischargedMeasured.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwBODDischargedMeasured", true, DataSourceUpdateMode.OnValidation, "");
            txtCODDischargedMeasured.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwCODDischargedMeasured", true, DataSourceUpdateMode.OnValidation, "");
            txtNDischargedMeasured.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwNDischargedMeasured", true, DataSourceUpdateMode.OnValidation, "");
            txtPDischargedMeasured.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwPDischargedMeasured", true, DataSourceUpdateMode.OnValidation, "");
            txtBODDischargedCalculated.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwBODDischargedCalculated", true, DataSourceUpdateMode.OnValidation, "");
            txtCODDischargedCalculated.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwCODDischargedCalculated", true, DataSourceUpdateMode.OnValidation, "");
            txtNDischargedCalculated.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwNDischargedCalculated", true, DataSourceUpdateMode.OnValidation, "");
            txtPDischargedCalculated.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwPDischargedCalculated", true, DataSourceUpdateMode.OnValidation, "");
            txtBODDischargedEstimated.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwBODDischargedEstimated", true, DataSourceUpdateMode.OnValidation, "");
            txtCODDischargedEstimated.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwCODDischargedEstimated", true, DataSourceUpdateMode.OnValidation, "");
            txtNDischargedEstimated.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwNDischargedEstimated", true, DataSourceUpdateMode.OnValidation, "");
            txtPDischargedEstimated.DataBindings.Add("Text", dataSet, TNAME_UWWTDS + ".uwwPDischargedEstimated", true, DataSourceUpdateMode.OnValidation, "");
        }

        static double SafeParse(String str)
        {
            if (str == null) return 0d;
            if (str.Length < 1) return 0d;
            return double.Parse(str);
        }

        void BODIncomingRowChanged(object sender, EventArgs e)
        {
            txtBODIncomingTotal.Text = String.Format("{0:F3}",
                SafeParse(txtBODIncomingMeasured.Text) +
                SafeParse(txtBODIncomingEstimated.Text) +
                SafeParse(txtBODIncomingCalculated.Text));
        }
        void CODIncomingRowChanged(object sender, EventArgs e)
        {
            txtCODIncomingTotal.Text = String.Format("{0:F3}",
                SafeParse(txtCODIncomingMeasured.Text) +
                SafeParse(txtCODIncomingEstimated.Text) +
                SafeParse(txtCODIncomingCalculated.Text));
        }
        void PIncomingRowChanged(object sender, EventArgs e)
        {
            txtPIncomingTotal.Text = String.Format("{0:F3}",
                SafeParse(txtPIncomingMeasured.Text) +
                SafeParse(txtPIncomingEstimated.Text) +
                SafeParse(txtPIncomingCalculated.Text));
        }
        void NIncomingRowChanged(object sender, EventArgs e)
        {
            txtNIncomingTotal.Text = String.Format("{0:F3}",
                SafeParse(txtNIncomingMeasured.Text) +
                SafeParse(txtNIncomingEstimated.Text) +
                SafeParse(txtNIncomingCalculated.Text));
        }
        void BODDischargedRowChanged(object sender, EventArgs e)
        {
            txtBODDischargedTotal.Text = String.Format("{0:F3}",
                SafeParse(txtBODDischargedMeasured.Text) +
                SafeParse(txtBODDischargedEstimated.Text) +
                SafeParse(txtBODDischargedCalculated.Text));
        }
        void CODDischargedRowChanged(object sender, EventArgs e)
        {
            txtCODDischargedTotal.Text = String.Format("{0:F3}",
                SafeParse(txtCODDischargedMeasured.Text) +
                SafeParse(txtCODDischargedEstimated.Text) +
                SafeParse(txtCODDischargedCalculated.Text));
        }
        void PDischargedRowChanged(object sender, EventArgs e)
        {
            txtPDischargedTotal.Text = String.Format("{0:F3}",
                SafeParse(txtPDischargedMeasured.Text) +
                SafeParse(txtPDischargedEstimated.Text) +
                SafeParse(txtPDischargedCalculated.Text));
        }
        void NDischargedRowChanged(object sender, EventArgs e)
        {
            txtNDischargedTotal.Text = String.Format("{0:F3}",
                SafeParse(txtNDischargedMeasured.Text) +
                SafeParse(txtNDischargedEstimated.Text) +
                SafeParse(txtNDischargedCalculated.Text));
        }

        private void OnSave(object sender, LinkLabelLinkClickedEventArgs e)
        {
            DataRowView row = BindingContext[dataSet, TNAME_UWWTDS].Current as DataRowView;
            if (row != null) row.EndEdit();

            string errorText = "";
            if ((sender != null) && (!ValidateForm(ref errorText, row != null ? row.Row.RowState : DataRowState.Detached))) {
                MessageBox.Show(this, "Please correct Form Errors before save:\r\n" + errorText, "Form not valid", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                return;
            }

            if (dataSet.HasChanges())
            {
                IDbConnection conn = mDataFactory.GetConnection();
                try
                {
                    bool enforceConstraints = dataSet.EnforceConstraints;
                    dataSet.EnforceConstraints = false;
                    try
                    {
                        int curPos = BindingContext[dataSet, TNAME_UWWTDS].Position;
                        IDbCommand cmd = mDataFactory.CreateCommand(CtrlUWWTDEdit.SELECT_ALL_UWWTD + CurrentRep.RepID, conn);
                        IDbDataAdapter adapter = mDataFactory.CreateFullDataAdapter(cmd);
                        mDataFactory.UpdateDataAdapter(adapter, dataSet, TNAME_UWWTDS);
                        mDataFactory.FillDataAdapter(adapter, dataSet, TNAME_UWWTDS);
                        if (BindingContext[dataSet, TNAME_UWWTDS].Count > curPos)
                        {
                            BindingContext[dataSet, TNAME_UWWTDS].Position = curPos;
                        }
                    }
                    finally
                    {
                        dataSet.EnforceConstraints = enforceConstraints;
                    }
                }
                finally
                {
                    conn.Close();
                }
            }
            row = BindingContext[dataSet, TNAME_UWWTDS].Current as DataRowView;
            //if (row != null) row.BeginEdit();
            if (sender != null)
                ShowSaveConfirmation();
        }

        private void OnDelete(object sender, LinkLabelLinkClickedEventArgs e) {
            if (ShowConfirmDelete()) {
                DataRowView currentRow = BindingContext[dataSet, CtrlUWWTDEdit.TNAME_UWWTDS].Current as DataRowView;
                if (currentRow == null) return;
                currentRow["uwwWasteWaterTreated"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwWasteWaterTreated"].DefaultValue;
                currentRow["uwwMethodWasteWaterTreated"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwMethodWasteWaterTreated"].DefaultValue;
                currentRow["uwwBODIncomingMeasured"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwBODIncomingMeasured"].DefaultValue;
                currentRow["uwwCODIncomingMeasured"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwCODIncomingMeasured"].DefaultValue;
                currentRow["uwwNIncomingMeasured"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwNIncomingMeasured"].DefaultValue;
                currentRow["uwwPIncomingMeasured"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwPIncomingMeasured"].DefaultValue;
                currentRow["uwwBODIncomingCalculated"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwBODIncomingCalculated"].DefaultValue;
                currentRow["uwwCODIncomingCalculated"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwCODIncomingCalculated"].DefaultValue;
                currentRow["uwwNIncomingCalculated"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwNIncomingCalculated"].DefaultValue;
                currentRow["uwwPIncomingCalculated"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwPIncomingCalculated"].DefaultValue;
                currentRow["uwwBODIncomingEstimated"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwBODIncomingEstimated"].DefaultValue;
                currentRow["uwwCODIncomingEstimated"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwCODIncomingEstimated"].DefaultValue;
                currentRow["uwwNIncomingEstimated"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwNIncomingEstimated"].DefaultValue;
                currentRow["uwwPIncomingEstimated"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwPIncomingEstimated"].DefaultValue;
                currentRow["uwwBODDischargedMeasured"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwBODDischargedMeasured"].DefaultValue;
                currentRow["uwwCODDischargedMeasured"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwCODDischargedMeasured"].DefaultValue;
                currentRow["uwwNDischargedMeasured"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwNDischargedMeasured"].DefaultValue;
                currentRow["uwwPDischargedMeasured"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwPDischargedMeasured"].DefaultValue;
                currentRow["uwwBODDischargedCalculated"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwBODDischargedCalculated"].DefaultValue;
                currentRow["uwwCODDischargedCalculated"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwCODDischargedCalculated"].DefaultValue;
                currentRow["uwwNDischargedCalculated"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwNDischargedCalculated"].DefaultValue;
                currentRow["uwwPDischargedCalculated"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwPDischargedCalculated"].DefaultValue;
                currentRow["uwwBODDischargedEstimated"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwBODDischargedEstimated"].DefaultValue;
                currentRow["uwwCODDischargedEstimated"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwCODDischargedEstimated"].DefaultValue;
                currentRow["uwwNDischargedEstimated"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwNDischargedEstimated"].DefaultValue;
                currentRow["uwwPDischargedEstimated"] = dataSet.Tables[TNAME_UWWTDS].Columns["uwwPDischargedEstimated"].DefaultValue;

                OnSave(null, null);

            }
        }
    }
}
