﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace at.uba.uwwtd2008.components
{
    public partial class CtrlMemberStateLevelEdit : UWWTDBaseCtrl
    {
        private const String SelectString = "Select * from T_MSLevel where repID = ";
        public const String TNAME_MSLEVEL = "T_MSLevel";

        DataSet dataSet = null;
        DataRowView currentRow = null;

        public CtrlMemberStateLevelEdit()
        {
            InitializeComponent();
        }

        public override void OnBackButtonClick()
        {
            currentRow.EndEdit();
            UWWTD2008MainForm mf = UWWTD2008MainForm.getMainForm(this);
            if (mf == null) return;

            if ((currentRow.Row.RowState != DataRowState.Unchanged)) 
            {
                if (!checkExitWithoutSave("Memberstate Level"))
                {
                    currentRow.BeginEdit();
                    return;
                }
                else
                {
                    currentRow.Row.RejectChanges();
                }
            }

            if (PrevControl != null) mf.getSplitterPanel().setContentPane(PrevControl);
            else mf.OpenDataEditMain();
        }

        private void OnIndustryEdit(object sender, LinkLabelLinkClickedEventArgs e)
        {
            ((UWWTD2008MainForm)(this.Parent.Parent.Parent.Parent)).OpenEditIndustry(this);
        }

        public Object CurrentMslID
        {
            get
            {
                return dataSet.Tables[TNAME_MSLEVEL].Rows[0]["mslID"];
            }
        }

        public override void OpenForm() {
            if (CurrentRep == null)
            {
                MessageBox.Show(UWWTD2008MainForm.getMainForm(this), "Please select a valid ReportPeriod first", "No ReportPeriod selected", MessageBoxButtons.OK, MessageBoxIcon.Error);
                UWWTD2008MainForm.getMainForm(this).OpenDataEditMain();
                return;
            }

            if (dataSet.Tables[TNAME_MSLEVEL].Rows.Count < 1)
            {
                DataRow newrow = dataSet.Tables[TNAME_MSLEVEL].NewRow();
                newrow["repID"] = CurrentRep.RepID;
                newrow["mslMS"] = CurrentRep.Reporter.State.Id;
                dataSet.Tables[TNAME_MSLEVEL].Rows.Add(newrow);
                editArt13Link.Enabled = false;
            }
            else
                editArt13Link.Enabled = true;

            mlabelReportedYear.Text = "Reported Year: " + CurrentRep.RepReportedPeriod;
            BindingContext[dataSet.Tables[TNAME_MSLEVEL]].Position = 0;
            currentRow = ((DataRowView) BindingContext[dataSet.Tables[TNAME_MSLEVEL]].Current);
            currentRow.BeginEdit();

            OnDataChanged(this, null);
        }

        public override void PerformDataBinding(DataSet dataSet)
        {
            this.dataSet = dataSet;

            IDbConnection conn = mDataFactory.GetConnection();
            try
            {
                IDbCommand cmd = mDataFactory.CreateCommand(SelectString + CurrentRep.RepID, conn);
                mDataFactory.FillDataAdapter(mDataFactory.CreateDataAdapter(cmd), dataSet, TNAME_MSLEVEL);

                mTxtMemberfYearly.DataBindings.Clear();
                mTxtMemberfYearly.DataBindings.Add("Text", dataSet.Tables[TNAME_MSLEVEL], "mslSludgeProduction", true, DataSourceUpdateMode.OnValidation, "", "###,###,###,###,###");
                mtxtMemberSoilAggr.DataBindings.Clear();
                mtxtMemberSoilAggr.DataBindings.Add("Text", dataSet.Tables[TNAME_MSLEVEL], "mslReuseSoilAgriculture", true, DataSourceUpdateMode.OnValidation, "", "###,###,###,###,###");
                mtxtMemberSoilAggrOthers.DataBindings.Clear();
                mtxtMemberSoilAggrOthers.DataBindings.Add("Text", dataSet.Tables[TNAME_MSLEVEL], "mslReuseOthers", true, DataSourceUpdateMode.OnValidation, "", "###,###,###,###,###");
                mtxtMemberLandfil.DataBindings.Clear();
                mtxtMemberLandfil.DataBindings.Add("Text", dataSet.Tables[TNAME_MSLEVEL], "mslDisposalLandfill", true, DataSourceUpdateMode.OnValidation, "", "###,###,###,###,###");
                mtxtMemberIncineration.DataBindings.Clear();
                mtxtMemberIncineration.DataBindings.Add("Text", dataSet.Tables[TNAME_MSLEVEL], "mslDisposalIncineration", true, DataSourceUpdateMode.OnValidation, "", "###,###,###,###,###");
                mtxtMemberDisposedOther.DataBindings.Clear();
                mtxtMemberDisposedOther.DataBindings.Add("Text", dataSet.Tables[TNAME_MSLEVEL], "mslDisposalOthers", true, DataSourceUpdateMode.OnValidation, "", "###,###,###,###,###");
                mtxtMemberPipline.DataBindings.Clear();
                mtxtMemberPipline.DataBindings.Add("Text", dataSet.Tables[TNAME_MSLEVEL], "mslDischargePipelines", true, DataSourceUpdateMode.OnValidation, "", "###,###,###,###,###");
                mtxtMemberShips.DataBindings.Clear();
                mtxtMemberShips.DataBindings.Add("Text", dataSet.Tables[TNAME_MSLEVEL], "mslDischargeShips", true, DataSourceUpdateMode.OnValidation, "", "###,###,###,###,###");
                mtxtMemberPipelShipsOthers.DataBindings.Clear();
                mtxtMemberPipelShipsOthers.DataBindings.Add("Text", dataSet.Tables[TNAME_MSLEVEL], "mslDischargeOthers", true, DataSourceUpdateMode.OnValidation, "", "###,###,###,###,###");
                mtxtMemberRate.DataBindings.Clear();
                mtxtMemberRate.DataBindings.Add("Text", dataSet.Tables[TNAME_MSLEVEL], "mslWWReusePerc", true, DataSourceUpdateMode.OnValidation, "", "###,###,###,###,###");
                mcheckMemberAgri.DataBindings.Clear();
                mcheckMemberAgri.DataBindings.Add("Checked", dataSet.Tables[TNAME_MSLEVEL], "mslWWReuseAgri", true, DataSourceUpdateMode.OnValidation, false);
                mcheckMemberIndutry.DataBindings.Clear();
                mcheckMemberIndutry.DataBindings.Add("Checked", dataSet.Tables[TNAME_MSLEVEL], "mslWWReuseInd", true, DataSourceUpdateMode.OnValidation, false);
                mcheckMemberOther.DataBindings.Clear();
                mcheckMemberOther.DataBindings.Add("Checked", dataSet.Tables[TNAME_MSLEVEL], "mslWWReuseOther", true, DataSourceUpdateMode.OnValidation, false);
                mtxtMemberExplainOthers.DataBindings.Clear();
                mtxtMemberExplainOthers.DataBindings.Add("Text", dataSet.Tables[TNAME_MSLEVEL], "mslWWReuseExplain", true, DataSourceUpdateMode.OnValidation, "");
                mtxtMemberRemark.DataBindings.Clear();
                mtxtMemberRemark.DataBindings.Add("Text", dataSet.Tables[TNAME_MSLEVEL], "mslRemarks", true, DataSourceUpdateMode.OnValidation, "");
            }
            finally
            {
                conn.Close();
            }
        }

        private void OnSaveClicked(object sender, LinkLabelLinkClickedEventArgs e) {
            string errorText = "";
            if ((e != null) && (!ValidateForm(ref errorText, currentRow != null ? currentRow.Row.RowState : DataRowState.Detached))) {
                MessageBox.Show(this, "Please correct Form Errors before save:\r\n" + errorText, "Form not valid", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                return;
            }

            IDbConnection conn = mDataFactory.GetConnection();
            try
            {
                currentRow.EndEdit();
                if (dataSet.HasChanges())
                {
                    IDbCommand cmd = mDataFactory.CreateCommand(SelectString + CurrentRep.RepID, conn);
                    mDataFactory.UpdateDataAdapter(mDataFactory.CreateFullDataAdapter(cmd), dataSet, TNAME_MSLEVEL);
                    editArt13Link.Enabled = true;
                }
                BindingContext[dataSet.Tables[TNAME_MSLEVEL]].Position = 0;
                currentRow = ((DataRowView)BindingContext[dataSet.Tables[TNAME_MSLEVEL]].Current);
                currentRow.BeginEdit();
            }
            finally
            {
                conn.Close();
            }

            ShowSaveConfirmation();
        }

        private void OnDataChanged(object sender, EventArgs e)
        {
            DataRowView row = (DataRowView)BindingContext[dataSet.Tables[TNAME_MSLEVEL]].Current;
            if (row == null)
            {
                sumDischSurface.Text = "";
                sumDisposed.Text = "";
                sumReused.Text = "";
                return;
            }

            bool hasItem = false;
            float sumItem = 0;
            if (!(row["mslDischargePipelines"] is DBNull))
            {
                hasItem = true;
                sumItem += (float)row["mslDischargePipelines"];
            }
            if (!(row["mslDischargeShips"] is DBNull))
            {
                hasItem = true;
                sumItem += (float)row["mslDischargeShips"];
            }
            if (!(row["mslDischargeOthers"] is DBNull))
            {
                hasItem = true;
                sumItem += (float)row["mslDischargeOthers"];
            }
            if (hasItem)
            {
                sumDischSurface.Text = sumItem.ToString("###,###,###,###,###");
            }
            else
            {
                sumDischSurface.Text = "";
            }

            hasItem = false;
            sumItem = 0;
            if (!(row["mslReuseSoilAgriculture"] is DBNull))
            {
                hasItem = true;
                sumItem += (float)row["mslReuseSoilAgriculture"];
            }
            if (!(row["mslReuseOthers"] is DBNull))
            {
                hasItem = true;
                sumItem += (float)row["mslReuseOthers"];
            }
            if (hasItem)
            {
                sumReused.Text = sumItem.ToString("###,###,###,###,###");
            }
            else
            {
                sumReused.Text = "";
            }

            hasItem = false;
            sumItem = 0;
            if (!(row["mslDisposalLandfill"] is DBNull))
            {
                hasItem = true;
                sumItem += (float)row["mslDisposalLandfill"];
            }
            if (!(row["mslDisposalIncineration"] is DBNull))
            {
                hasItem = true;
                sumItem += (float)row["mslDisposalIncineration"];
            }
            if (!(row["mslDisposalOthers"] is DBNull))
            {
                hasItem = true;
                sumItem += (float)row["mslDisposalOthers"];
            }
            if (hasItem)
            {
                sumDisposed.Text = sumItem.ToString();
            }
            else
            {
                sumDisposed.Text = "";
            }
        }
    }
}
