﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace at.uba.uwwtd2008.components
{
    public partial class CtrlRA54 : UWWTDBaseCtrl
    {
        DataSet dataSet;
        DataView dataView;
        DataRowView currentRow;

        public CtrlRA54()
        {
            InitializeComponent();
        }

        public override void OnBackButtonClick()
        {
            UWWTD2008MainForm mf = UWWTD2008MainForm.getMainForm(this);
            if (mf == null) return;

            if (currentRow != null) currentRow.EndEdit();
            if (dataSet.HasChanges()) {
                if (!checkExitWithoutSave("Receiving Area")) return;
                dataSet.RejectChanges();
            }

            if (PrevControl != null) mf.getSplitterPanel().setContentPane(PrevControl);
            else mf.OpenDataEditMain();
        }

        public override void OpenForm()
        {
            DataView dv = ((CtrlRaSA)PrevControl).RASADataView;
            this.BindingContext = PrevControl.BindingContext;
            PerformActualDataBinding(dv);
            //BindingContext[dv].Position = PrevControl.BindingContext[dv].Position;
            currentRow = (DataRowView) BindingContext[dv].Current;
        }

        public override void PerformDataBinding(DataSet dataSet)
        {
            this.dataSet = dataSet;
        }

        public void PerformActualDataBinding(DataView dv)
        {
            if (dataView != dv)
            {
                // only perform binding if dv is new
                dataView = dv;

                txtCode.DataBindings.Clear();
                txtCode.DataBindings.Add("Text", dv, "rcaCode", true, DataSourceUpdateMode.OnValidation, "");
                txtName.DataBindings.Clear();
                txtName.DataBindings.Add("Text", dv, "rcaName", true, DataSourceUpdateMode.OnValidation, "");
                txtDateArt54.DataBindings.Clear();
                txtDateArt54.DataBindings.Add("Text", dv, "rcaDateArt54", true, DataSourceUpdateMode.OnValidation, "", "d");

                txtPlants.DataBindings.Clear();
                txtPlants.DataBindings.Add("Text", dv, "rcaPlants", true, DataSourceUpdateMode.OnValidation, "");
                txtPlantsCapacity.DataBindings.Clear();
                txtPlantsCapacity.DataBindings.Add("Text", dv, "rcaPlantsCapacity", true, DataSourceUpdateMode.OnValidation, "");

                txtNIncomingMeasured.DataBindings.Clear();
                txtNIncomingMeasured.DataBindings.Add("Text", dv, "rcaNIncomingMeasured", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");
                txtNIncomingCalculated.DataBindings.Clear();
                txtNIncomingCalculated.DataBindings.Add("Text", dv, "rcaNIncomingCalculated", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");
                txtNIncomingEstimated.DataBindings.Clear();
                txtNIncomingEstimated.DataBindings.Add("Text", dv, "rcaNIncomingEstimated", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");
                txtPIncomingMeasured.DataBindings.Clear();
                txtPIncomingMeasured.DataBindings.Add("Text", dv, "rcaPIncomingMeasured", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");
                txtPIncomingCalculated.DataBindings.Clear();
                txtPIncomingCalculated.DataBindings.Add("Text", dv, "rcaPIncomingCalculated", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");
                txtPIncomingEstimated.DataBindings.Clear();
                txtPIncomingEstimated.DataBindings.Add("Text", dv, "rcaPIncomingEstimated", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");

                txtNDischargedMeasured.DataBindings.Clear();
                txtNDischargedMeasured.DataBindings.Add("Text", dv, "rcaNDischargedMeasured", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");
                txtNDischargedCalculated.DataBindings.Clear();
                txtNDischargedCalculated.DataBindings.Add("Text", dv, "rcaNDischargedCalculated", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");
                txtNDischargedEstimated.DataBindings.Clear();
                txtNDischargedEstimated.DataBindings.Add("Text", dv, "rcaNDischargedEstimated", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");
                txtPDischargedMeasured.DataBindings.Clear();
                txtPDischargedMeasured.DataBindings.Add("Text", dv, "rcaPDischargedMeasured", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");
                txtPDischargedCalculated.DataBindings.Clear();
                txtPDischargedCalculated.DataBindings.Add("Text", dv, "rcaPDischargedCalculated", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");
                txtPDischargedEstimated.DataBindings.Clear();
                txtPDischargedEstimated.DataBindings.Add("Text", dv, "rcaPDischargedEstimated", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");

                txtNIncomingMeasured.TextChanged += new EventHandler(NIncomingTextChanged);
                txtNIncomingCalculated.TextChanged += new EventHandler(NIncomingTextChanged);
                txtNIncomingEstimated.TextChanged += new EventHandler(NIncomingTextChanged);
                txtPIncomingMeasured.TextChanged += new EventHandler(PIncomingTextChanged);
                txtPIncomingCalculated.TextChanged += new EventHandler(PIncomingTextChanged);
                txtPIncomingEstimated.TextChanged += new EventHandler(PIncomingTextChanged);

                txtNDischargedMeasured.TextChanged += new EventHandler(NDischargedTextChanged);
                txtNDischargedCalculated.TextChanged += new EventHandler(NDischargedTextChanged);
                txtNDischargedEstimated.TextChanged += new EventHandler(NDischargedTextChanged);
                txtPDischargedMeasured.TextChanged += new EventHandler(PDischargedTextChanged);
                txtPDischargedCalculated.TextChanged += new EventHandler(PDischargedTextChanged);
                txtPDischargedEstimated.TextChanged += new EventHandler(PDischargedTextChanged);

                txtRemarks.DataBindings.Clear();
                txtRemarks.DataBindings.Add("Text", dv, "rcaRemarks", true, DataSourceUpdateMode.OnValidation, "");
            }
        }
        static double SafeParse(TextBox str)
        {
            if (str == null) return 0d;
            if (str.Text == null) return 0d;
            if (str.Text.Length < 1) return 0d;
            try
            {
                return double.Parse(str.Text);
            }
            catch (Exception)
            {
                str.Text = "";
                return 0d;
            }
        }

        void NIncomingTextChanged(object sender, EventArgs e)
        {
            txtNIncomingTotal.Text = String.Format("{0:#,#,#,#.###}",
                SafeParse(txtNIncomingMeasured) +
                SafeParse(txtNIncomingEstimated) +
                SafeParse(txtNIncomingCalculated));
        }
        void PIncomingTextChanged(object sender, EventArgs e)
        {
            txtPIncomingTotal.Text = String.Format("{0:#,#,#,#.###}",
                SafeParse(txtPIncomingMeasured) +
                SafeParse(txtPIncomingEstimated) +
                SafeParse(txtPIncomingCalculated));
        }
        void NDischargedTextChanged(object sender, EventArgs e)
        {
            txtNDischargedTotal.Text = String.Format("{0:#,#,#,#.###}",
                SafeParse(txtNDischargedMeasured) +
                SafeParse(txtNDischargedEstimated) +
                SafeParse(txtNDischargedCalculated));
        }
        void PDischargedTextChanged(object sender, EventArgs e)
        {
            txtPDischargedTotal.Text = String.Format("{0:#,#,#,#.###}",
                SafeParse(txtPDischargedMeasured) +
                SafeParse(txtPDischargedEstimated) +
                SafeParse(txtPDischargedCalculated));
        }

        private void OnSave(object sender, LinkLabelLinkClickedEventArgs e)
        {
            ((CtrlRaSA)PrevControl).LinkSaveClicked(sender, e);
        }
    }
}
