﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace at.uba.uwwtd2008.components
{
    public partial class CtrlRaArt5854 : UWWTDBaseCtrl
    {
        public const string TNAME_RA = CtrlReceivingAreasEdit.TNAME_RA;

        private DataSet dataSet;
        private DataRowView currentRow;
        
        public CtrlRaArt5854()
        {
            InitializeComponent();
        }

        public override void OnBackButtonClick()
        {
            if (currentRow != null) currentRow.EndEdit();
            if (dataSet.HasChanges()) {
                if (!checkExitWithoutSave("Receiving Area")) return;
                dataSet.RejectChanges();
            }

            if (currentRow.Row.RowState == DataRowState.Added) dataSet.Tables[TNAME_RA].Rows.Remove(currentRow.Row);

            UWWTD2008MainForm mf = UWWTD2008MainForm.getMainForm(this);
            if (mf == null) return;

            if (PrevControl != null) mf.getSplitterPanel().setContentPane(PrevControl);
            else mf.OpenDataEditMain();
        }

        public override void OpenForm()
        {
            BindingContext[dataSet, TNAME_RA].Position = PrevControl.BindingContext[dataSet, TNAME_RA].Position;
            // fill the type-box per hand
            DataRowView rowView = BindingContext[dataSet, TNAME_RA].Current as DataRowView;
            if (rowView != null)
            {
                currentRow = rowView;
                txtRAType.Text = mDataFactory.getLOVTable().Rows.Find(rowView["rcaType"])["lovWert"] as string;
                txtRcaName.Text = CurrentRep.Reporter.State.Value;
                txtRcaCode.ReadOnly = rowView.Row.RowState != DataRowState.Added;
            }
            else
            {
                // we should never end up in here
                currentRow = null;
                txtRAType.Text = "";
            }

            NIncomingTextChanged(null, null);
            PIncomingTextChanged(null, null);
            NIncomingTextChanged(null, null);
            PIncomingTextChanged(null, null);
            //calculateAllUWWTPParams();
            currentRow.BeginEdit();
        }

        //private void calculateAllUWWTPParams()
        //{
        //    long loadEntering = 0;
        //    long numberOfUWWTDs = 0;
        //    foreach (DataRow row in dataSet.Tables[CtrlUWWTDEdit.TNAME_UWWTDS].Rows)
        //    {
        //        if (row.RowState == DataRowState.Deleted) continue; // do not count deleted rows
        //        numberOfUWWTDs++;
        //        if ((row["uwwLoadEnteringUWWTP"] != null) && !(row["uwwLoadEnteringUWWTP"] is DBNull))
        //            loadEntering += (int) row["uwwLoadEnteringUWWTP"];
        //    }

        //    txtNumberOfUWWTPs.Text = numberOfUWWTDs.ToString();
        //    txtSumOrganicLoadUWWTPs.Text = loadEntering.ToString("#,#,#,#,#,#");
        //}

        public override void PerformDataBinding(DataSet dataSet)
        {
            this.dataSet = dataSet;
            BindingContext[dataSet].Position = 0;
            

            txtRcaCode.DataBindings.Clear();
            txtRcaCode.DataBindings.Add("Text", dataSet, TNAME_RA + ".rcaCode", true, DataSourceUpdateMode.OnValidation, "");

            txtRcaDate54.DataBindings.Clear();
            txtRcaDate54.DataBindings.Add("Text", dataSet, TNAME_RA + ".rcaDateArt54", true, DataSourceUpdateMode.OnValidation, "", "d");
            txtRcaDate58.DataBindings.Clear();
            txtRcaDate58.DataBindings.Add("Text", dataSet, TNAME_RA + ".rcaDateArt58", true, DataSourceUpdateMode.OnValidation, "", "d");

            txtSumOrganicLoadUWWTPs.DataBindings.Clear();
            txtSumOrganicLoadUWWTPs.DataBindings.Add("Text", dataSet, TNAME_RA + ".rcaPlantsCapacity", true, DataSourceUpdateMode.OnValidation, "", "#,#,#,#,#.###");
            txtNumberOfUWWTPs.DataBindings.Clear();
            txtNumberOfUWWTPs.DataBindings.Add("Text", dataSet, TNAME_RA + ".rcaPlants", true, DataSourceUpdateMode.OnValidation, "", "#,#,#,#,##.###");

            txtRemarks.DataBindings.Clear();
            txtRemarks.DataBindings.Add("Text", dataSet, TNAME_RA + ".rcaRemarks", true, DataSourceUpdateMode.OnValidation, "");

            txtNIncomingMeasured.DataBindings.Clear();
            txtNIncomingMeasured.DataBindings.Add("Text", dataSet, TNAME_RA + ".rcaNIncomingMeasured", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");
            txtNIncomingCalculated.DataBindings.Clear();
            txtNIncomingCalculated.DataBindings.Add("Text", dataSet, TNAME_RA + ".rcaNIncomingCalculated", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");
            txtNIncomingEstimated.DataBindings.Clear();
            txtNIncomingEstimated.DataBindings.Add("Text", dataSet, TNAME_RA + ".rcaNIncomingEstimated", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");
            txtPIncomingMeasured.DataBindings.Clear();
            txtPIncomingMeasured.DataBindings.Add("Text", dataSet, TNAME_RA + ".rcaPIncomingMeasured", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");
            txtPIncomingCalculated.DataBindings.Clear();
            txtPIncomingCalculated.DataBindings.Add("Text", dataSet, TNAME_RA + ".rcaPIncomingCalculated", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");
            txtPIncomingEstimated.DataBindings.Clear();
            txtPIncomingEstimated.DataBindings.Add("Text", dataSet, TNAME_RA + ".rcaPIncomingEstimated", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");

            txtNDischargedMeasured.DataBindings.Clear();
            txtNDischargedMeasured.DataBindings.Add("Text", dataSet, TNAME_RA + ".rcaNDischargedMeasured", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");
            txtNDischargedCalculated.DataBindings.Clear();
            txtNDischargedCalculated.DataBindings.Add("Text", dataSet, TNAME_RA + ".rcaNDischargedCalculated", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");
            txtNDischargedEstimated.DataBindings.Clear();
            txtNDischargedEstimated.DataBindings.Add("Text", dataSet, TNAME_RA + ".rcaNDischargedEstimated", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");
            txtPDischargedMeasured.DataBindings.Clear();
            txtPDischargedMeasured.DataBindings.Add("Text", dataSet, TNAME_RA + ".rcaPDischargedMeasured", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");
            txtPDischargedCalculated.DataBindings.Clear();
            txtPDischargedCalculated.DataBindings.Add("Text", dataSet, TNAME_RA + ".rcaPDischargedCalculated", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");
            txtPDischargedEstimated.DataBindings.Clear();
            txtPDischargedEstimated.DataBindings.Add("Text", dataSet, TNAME_RA + ".rcaPDischargedEstimated", true, DataSourceUpdateMode.OnValidation, "", "#,#,#.###");

            txtNIncomingMeasured.TextChanged += new EventHandler(NIncomingTextChanged);
            txtNIncomingCalculated.TextChanged += new EventHandler(NIncomingTextChanged);
            txtNIncomingEstimated.TextChanged += new EventHandler(NIncomingTextChanged);
            txtPIncomingMeasured.TextChanged += new EventHandler(PIncomingTextChanged);
            txtPIncomingCalculated.TextChanged += new EventHandler(PIncomingTextChanged);
            txtPIncomingEstimated.TextChanged += new EventHandler(PIncomingTextChanged);

            txtNDischargedMeasured.TextChanged += new EventHandler(NDischargedTextChanged);
            txtNDischargedCalculated.TextChanged += new EventHandler(NDischargedTextChanged);
            txtNDischargedEstimated.TextChanged += new EventHandler(NDischargedTextChanged);
            txtPDischargedMeasured.TextChanged += new EventHandler(PDischargedTextChanged);
            txtPDischargedCalculated.TextChanged += new EventHandler(PDischargedTextChanged);
            txtPDischargedEstimated.TextChanged += new EventHandler(PDischargedTextChanged);
        }

        static double SafeParse(TextBox str)
        {
            if (str == null) return 0d;
            if (str.Text == null) return 0d;
            if (str.Text.Length < 1) return 0d;
            try
            {
                return double.Parse(str.Text);
            }
            catch (Exception)
            {
                str.Text = "";
                return 0d;
            }
        }

        void NIncomingTextChanged(object sender, EventArgs e)
        {
            txtNIncomingTotal.Text = String.Format("{0:#,#,#,#.###}",
                SafeParse(txtNIncomingMeasured) +
                SafeParse(txtNIncomingEstimated) +
                SafeParse(txtNIncomingCalculated));
        }
        void PIncomingTextChanged(object sender, EventArgs e)
        {
            txtPIncomingTotal.Text = String.Format("{0:#,#,#,#.###}",
                SafeParse(txtPIncomingMeasured) +
                SafeParse(txtPIncomingEstimated) +
                SafeParse(txtPIncomingCalculated));
        }
        void NDischargedTextChanged(object sender, EventArgs e)
        {
            txtNDischargedTotal.Text = String.Format("{0:#,#,#,#.###}",
                SafeParse(txtNDischargedMeasured) +
                SafeParse(txtNDischargedEstimated) +
                SafeParse(txtNDischargedCalculated));
        }
        void PDischargedTextChanged(object sender, EventArgs e)
        {
            txtPDischargedTotal.Text = String.Format("{0:#,#,#,#.###}",
                SafeParse(txtPDischargedMeasured) +
                SafeParse(txtPDischargedEstimated) +
                SafeParse(txtPDischargedCalculated));
        }

        private void OnSaveLinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            string errorText = "";
            if (!ValidateForm(ref errorText, currentRow != null ? currentRow.Row.RowState : DataRowState.Detached)) {
                MessageBox.Show(this, "Please correct Form Errors before save:\r\n" + errorText, "Form not valid", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                return;
            }
            currentRow.EndEdit();
            saveData();
            ShowSaveConfirmation();
        }

        private void OnDeleteLinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            if (ShowConfirmDelete()) {
                if ((currentRow.Row.RowState == DataRowState.Added) ||
                    (currentRow.Row.RowState == DataRowState.Detached)) {
                    dataSet.Tables[TNAME_RA].Rows.Remove(currentRow.Row);
                }
                else {
                    currentRow.Delete();
                    currentRow.EndEdit();
                    saveData();
                }
                UWWTD2008MainForm mf = UWWTD2008MainForm.getMainForm(this);
                if (mf == null) return;

                if (PrevControl != null) mf.getSplitterPanel().setContentPane(PrevControl);
                else mf.OpenDataEditMain();
            }
        }

        private void saveData()
        {
            IDbConnection conn = mDataFactory.GetConnection();
            try
            {
                IDbDataAdapter adapter = mDataFactory.CreateFullDataAdapter(
                            mDataFactory.CreateCommand("select * from T_ReceivingAreas WHERE repID = " + CurrentRep.RepID, conn)
                        );

                mDataFactory.UpdateDataAdapter(adapter, dataSet, TNAME_RA);
                mDataFactory.FillDataAdapter(adapter, dataSet, TNAME_RA);
                // check, if this was a delete operation ....
                if (dataSet.Tables[TNAME_RA].Rows.Count > 0)
                {
                    DataRowView rowView = BindingContext[dataSet, TNAME_RA].Current as DataRowView;
                    if (rowView != null)
                    {
                        currentRow = rowView;
                        txtRAType.Text = mDataFactory.getLOVTable().Rows.Find(rowView.Row["rcaType"])["lovWert"] as string;
                        txtRcaName.Text = CurrentRep.Reporter.State.Value;
                        txtRcaCode.ReadOnly = rowView.Row.RowState != DataRowState.Added;
                    }
                }
            }
            finally
            {
                conn.Close();
            }
        }

        protected override bool ValidateForm(ref string errorText, DataRowState state) {
            bool retVal = true;
            if ((txtRcaCode.Text == null) || (txtRcaCode.Text.Length < 2) || !(txtRcaCode.Text.StartsWith(CurrentRep.Reporter.State.Key))) {
                errorText += "ID has to start with " + CurrentRep.Reporter.State.Key;
                txtRcaCode.BackColor = UWWTD2008.ColError;
                retVal = false;
            }
            else {
                txtRcaCode.BackColor = UWWTD2008.ColNorm;
            }

            return retVal;
        }
    }
}
