﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using at.uba.uwwtd2008.DataAccess;

namespace at.uba.uwwtd2008.components
{
    public partial class CtrlRaSA : UWWTDBaseCtrl
    {
        private DataSet dataSet;
        private DataRowView currentRow;
        private DataView dv;

        public const string TNAME_RA = CtrlReceivingAreasEdit.TNAME_RA;

        public CtrlRaSA()
        {
            InitializeComponent();
        }

        public override void OnBackButtonClick()
        {
            UWWTD2008MainForm mf = UWWTD2008MainForm.getMainForm(this);
            if (mf == null) return;

            if (currentRow != null) currentRow.EndEdit();
            if (dataSet.HasChanges())
            {
                if (!checkExitWithoutSave("Receiving Areas"))
                {
                    if (currentRow != null) currentRow.BeginEdit();
                    return;
                }
                dataSet.RejectChanges();
            }

            if (PrevControl != null) mf.getSplitterPanel().setContentPane(PrevControl);
            else mf.OpenDataEditMain();
        }

        public override void OpenForm()
        {
            if (BindingContext[dv].Count > 0)
                currentRow = (DataRowView)BindingContext[dv].Current;
            updateComponentView();
        }

        public DataView RASADataView { get { return dv; } }

        public override void PerformDataBinding(DataSet dataSet)
        {
            this.dataSet = dataSet;

            dv = new DataView(dataSet.Tables[TNAME_RA]);

            BindingContext[dv].CurrentChanged += new EventHandler(CurrentDVDataSetChanged);

            DataView dvlov = new DataView(mDataFactory.getLOVTable());
            string rowFilter = "";

            DataView dvStates = mDataFactory.getLovSTAT();

            foreach (DataRow row in mDataFactory.getRATYPLovValues().Select("lovKey='SA' OR lovKey='CSA'"))
            {
                if (rowFilter.Length > 5)
                    rowFilter += " OR ";
                rowFilter += "lovID = " + row["lovID"];
            }
            dvlov.RowFilter = rowFilter;
            dv.RowFilter = rowFilter.Replace("lovID", "rcaType");
            dv.AllowEdit = true;
            dv.AllowDelete = true;
            dv.AllowNew = true;

            DataView dvSA = new DataView(dataSet.Tables[TNAME_RA]);
            dvSA.RowFilter = "rcaType = " + mDataFactory.getRATYPLovValues().Select("lovKey='SA'")[0]["lovID"];

            gridSensitiveArea.AutoGenerateColumns = false;
            gridSensitiveArea.DataSource = dv;
            //((DataGridViewComboBoxColumn)gridSensitiveArea.Columns["rcaType"]).DataSource = dvlov;
            //((DataGridViewComboBoxColumn)gridSensitiveArea.Columns["rcaType"]).DisplayMember = "lovWert";
            //((DataGridViewComboBoxColumn)gridSensitiveArea.Columns["rcaType"]).ValueMember = "lovID";
            //((DataGridViewComboBoxColumn)gridSensitiveArea.Columns["rcaType"]).DataPropertyName = "rcaType";
            //((DataGridViewComboBoxColumn)gridSensitiveArea.Columns["rowState"]).DataSource = dvStates;
            //((DataGridViewComboBoxColumn)gridSensitiveArea.Columns["rowState"]).ValueMember = "lovID";
            //((DataGridViewComboBoxColumn)gridSensitiveArea.Columns["rowState"]).DisplayMember = "lovWert";
            //((DataGridViewComboBoxColumn)gridSensitiveArea.Columns["rowState"]).DataPropertyName = "rcaState";

            cmbState.DataBindings.Clear();
            cmbState.DataSource = dvStates;
            cmbState.ValueMember = "lovID";
            cmbState.DisplayMember = "lovWert";
            cmbState.DataBindings.Add("SelectedValue", dv, "rcaState");

            cmbRaType.DataBindings.Clear();
            cmbRaType.DataSource = dvlov;
            cmbRaType.DisplayMember = "lovWert";
            cmbRaType.ValueMember = "lovID";
            cmbRaType.DataBindings.Add("SelectedValue", dv, "rcaType");

            cmbSensitiveArea.DataBindings.Clear();
            cmbSensitiveArea.DataSource = dvSA;
            cmbSensitiveArea.DisplayMember = "rcaCode";
            cmbSensitiveArea.ValueMember = "rcaID";
            cmbSensitiveArea.DataBindings.Add("SelectedValue", dv, "rcaSensitiveArea", true, DataSourceUpdateMode.OnValidation, "");

            txtCode.DataBindings.Clear();
            txtCode.DataBindings.Add("Text", dv, "rcaCode", true, DataSourceUpdateMode.OnValidation, "");
            txtName.DataBindings.Clear();
            txtName.DataBindings.Add("Text", dv, "rcaName", true, DataSourceUpdateMode.OnValidation, "");

            txtDateDesignation.DataBindings.Clear();
            txtDateDesignation.DataBindings.Add("Text", dv, "rcaDateDesignation", true, DataSourceUpdateMode.OnValidation, "", "d");

            optArt54.DataBindings.Clear();
            optArt54.DataBindings.Add("Checked", dv, "rcaArt54Applied", true, DataSourceUpdateMode.OnValidation, false);

            ckbANitro.DataBindings.Clear();
            ckbANitro.DataBindings.Add("Checked", dv, "rcaANitro", true, DataSourceUpdateMode.OnValidation, false);
            ckbAPhos.DataBindings.Clear();
            ckbAPhos.DataBindings.Add("Checked", dv, "rcaAPhos", true, DataSourceUpdateMode.OnValidation, false);
            ckbB.DataBindings.Clear();
            ckbB.DataBindings.Add("Checked", dv, "rcaB", true, DataSourceUpdateMode.OnValidation, false);
            ckbC.DataBindings.Clear();
            ckbC.DataBindings.Add("Checked", dv, "rcaC", true, DataSourceUpdateMode.OnValidation, false);

            txtCRelevantDirective.DataBindings.Clear();
            txtCRelevantDirective.DataBindings.Add("Text", dv, "rcaCRelevantDirective", true, DataSourceUpdateMode.OnValidation, "");
            txtCIDOtherDirective.DataBindings.Clear();
            txtCIDOtherDirective.DataBindings.Add("Text", dv, "rcaCIDOtherDirective", true, DataSourceUpdateMode.OnValidation, "");

            txtCDateOtherDirectiv.DataBindings.Clear();
            txtCDateOtherDirectiv.DataBindings.Add("Text", dv, "rcaCDateOtherDirective", true, DataSourceUpdateMode.OnValidation, "", "d");

            txtGIS.DataBindings.Clear();
            txtGIS.DataBindings.Add("Text", dv, "rcaGIS", true, DataSourceUpdateMode.OnValidation, "");

            txtRemarks.DataBindings.Clear();
            txtRemarks.DataBindings.Add("Text", dv, "rcaRemarks", true, DataSourceUpdateMode.OnValidation, "");
        }

        void CurrentDVDataSetChanged(object sender, EventArgs e)
        {
            if (currentRow != null)
            {
                currentRow.CancelEdit();
                currentRow = null;
            }

            if (BindingContext[dv].Position >= 0)
            {
                DataRowView view = BindingContext[dv].Current as DataRowView;
                if (view != null)
                {
                    currentRow = view;
                    currentRow.BeginEdit();
                    if (currentRow.Row.RowState == DataRowState.Added)
                    {
                        txtCode.BackColor = UWWTD2008.ColMandatory;
                        txtName.BackColor = UWWTD2008.ColMandatory;
                        txtDateDesignation.BackColor = UWWTD2008.ColMandatory;
                        ckbANitro.BackColor = UWWTD2008.ColMandatory;
                        ckbAPhos.BackColor = UWWTD2008.ColMandatory;
                        ckbB.BackColor = UWWTD2008.ColMandatory;
                        ckbC.BackColor = UWWTD2008.ColMandatory;
                        txtGIS.BackColor = UWWTD2008.ColMandatory;
                    }
                    else
                    {
                        txtCode.BackColor = UWWTD2008.ColNorm;
                        txtName.BackColor = UWWTD2008.ColNorm;
                        txtDateDesignation.BackColor = UWWTD2008.ColNorm;
                        ckbANitro.BackColor = UWWTD2008.ColNorm;
                        ckbAPhos.BackColor = UWWTD2008.ColNorm;
                        ckbB.BackColor = UWWTD2008.ColNorm;
                        ckbC.BackColor = UWWTD2008.ColNorm;
                        txtGIS.BackColor = UWWTD2008.ColNorm;
                    }
                }
            }

            updateComponentView();
        }

        private void updateComponentView()
        {
            if (currentRow == null)
            {
                foreach (Binding b in BindingContext[dv].Bindings)
                {
                    Control ctrl = b.BindableComponent as Control;
                    if (ctrl != null) ctrl.Enabled = false;
                }

                cmdDelete.Enabled = false;
            } // if
            else
            {
                foreach (Binding b in BindingContext[dv].Bindings)
                {
                    Control ctrl = b.BindableComponent as Control;
                    if (ctrl != null) ctrl.Enabled = true;
                }

                cmdDelete.Enabled = true;
                txtCode.ReadOnly = currentRow.Row.RowState != DataRowState.Added;
                txtName.ReadOnly = false;
                cmbRaType.Enabled = currentRow.Row.RowState == DataRowState.Added;
            }
        }

        private void OnCurrentSAChanged(object sender, EventArgs e)
        {
            //cmdDelete.Enabled = gridSensitiveArea.RowCount > 0;

            //if (gridSensitiveArea.CurrentRow == null)
            //{
            //    if (currentRow != null) currentRow.CancelEdit();
            //    currentRow = null;
            //}
            //else
            //{
            //    if (currentRow != null)
            //        currentRow.CancelEdit();

            //    DataRowView view = gridSensitiveArea.CurrentRow.DataBoundItem as DataRowView;
            //    if (view != null)
            //    {
            //        if (view.Row == currentRow) return; // nothing changed - we do nothing
            //        currentRow = view.Row;
            //        currentRow.BeginEdit();
            //    }
            //}
        }

        private void OnInsertSA(object sender, EventArgs e)
        {
            DataRow newRow = dataSet.Tables[TNAME_RA].NewRow();
            newRow["repID"] = CurrentRep.RepID;
            newRow["rcaState"] = mDataFactory.getLovRowByKey("STAT", "1")["lovID"];
            newRow["rcaType"] = mDataFactory.getRATYPLovValues().Select("lovKey='SA'")[0]["lovID"];
            newRow["rcaCode"] = CurrentRep.Reporter.State.Key;
            dataSet.Tables[TNAME_RA].Rows.Add(newRow);
            BindingContext[dv].Position = BindingContext[dv].Count - 1;
        }

        private void OnArt54DataClick(object sender, EventArgs e)
        {
            UWWTD2008MainForm mf = UWWTD2008MainForm.getMainForm(this);
            if (mf == null) return;
            mf.OpenRa54Edit(this);
        }

        private void OnArt54StateChanged(object sender, EventArgs e)
        {
            cmdFormRa54.Enabled = optArt54.Checked;
            if (BindingContext[dv].Position >= 0)
                ((DataRowView)BindingContext[dv].Current)["rcaArt54Applied"] = optArt54.Checked;
            if (!optArt54.Checked) optArt523.Checked = true;
        }

        public void LinkSaveClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            if (currentRow != null)
                currentRow.EndEdit();

            string errorText = "";
            if (!ValidateForm(ref errorText, currentRow != null ? currentRow.Row.RowState : DataRowState.Detached)) {
                MessageBox.Show(this, "Please correct Form Errors before save:\r\n" + errorText, "Form not valid", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                return;
            }

            saveData();
            updateComponentView();
            ShowSaveConfirmation();
        }

        private void saveData()
        {
            IDbConnection conn = mDataFactory.GetConnection();
            try
            {
                IDbDataAdapter adapter = mDataFactory.CreateFullDataAdapter(
                            mDataFactory.CreateCommand("select * from T_ReceivingAreas WHERE repID = " + CurrentRep.RepID, conn)
                        );
                int curPos = BindingContext[dv].Position;
                mDataFactory.UpdateDataAdapter(adapter, dataSet, TNAME_RA);
                mDataFactory.FillDataAdapter(adapter, dataSet, TNAME_RA);
                if (BindingContext[dv].Count > curPos)
                    BindingContext[dv].Position = curPos;
            }
            finally
            {
                conn.Close();
            }
        }

        private void OnSelectedTypeChange(object sender, EventArgs e)
        {
            DataView dvTmp = mDataFactory.getLovViewByKey("RATYP");
            dvTmp.RowFilter += " AND lovKey = 'CSA'";
            cmbSensitiveArea.Visible = dvTmp[0]["lovID"].Equals(cmbRaType.SelectedValue);
            lblSensitiveArea.Visible = dvTmp[0]["lovID"].Equals(cmbRaType.SelectedValue);
        }

        private void OnSADelete(object sender, EventArgs e)
        {
            if (ShowConfirmDelete()) {
                if (BindingContext[dv].Count < 1) return;
                DataRowView row = (DataRowView)BindingContext[dv].Current;
                if (row != null) {
                    row.Delete();
                }
                saveData();
            }
        }

        protected override bool ValidateForm(ref string errorText, DataRowState state) {
            bool retVal = true;
            if ((txtCode.Text == null) || (txtCode.Text.Length < 2) || !(txtCode.Text.StartsWith(CurrentRep.Reporter.State.Key))) {
                errorText += "ID has to start with " + CurrentRep.Reporter.State.Key;
                txtCode.BackColor = state != DataRowState.Added ? UWWTD2008.ColError : UWWTD2008.ColMandatory ;
                retVal = false;
            }
            else {
                if ((dataSet.Tables[TNAME_RA].Select("rcaCode = '" + txtCode.Text + "'").Length > 0) &&
                    (dataSet.Tables[TNAME_RA].Select("rcaCode = '" + txtCode.Text + "'")[0] != currentRow.Row)) {
                    txtCode.BackColor = UWWTD2008.ColError;
                    if (errorText.Length > 1) errorText += "\r\n";
                    errorText += "Code for ID already used";
                    retVal = false;
                }
                else {
                    txtCode.BackColor = UWWTD2008.ColNorm;
                }
            }

            if ((txtName.Text == null) || (txtName.Text.Length < 1)) {
                if (errorText.Length > 0) errorText += "\r\n";
                errorText += "Name is Master Data";
                retVal = false;
                txtName.BackColor = UWWTD2008.ColError;
            }
            else {
                txtName.BackColor = UWWTD2008.ColNorm;
            }

            if ((txtDateDesignation.Text == null) || (txtDateDesignation.Text.Length < 1)) {
                if (errorText.Length > 0) errorText += "\r\n";
                errorText += "Designation Date is Master Data";
                retVal = false;
                txtDateDesignation.BackColor = UWWTD2008.ColError;
            }
            else {
                if ((currentRow["rcaDateDesignation"] != null) && !(currentRow["rcaDateDesignation"] is DBNull))
                {
                    DateTime date = (DateTime) currentRow["rcaDateDesignation"];
                    if (date.CompareTo(UWWTD2008.MIN_VALID_DATE) < 0)
                    {
                        if (errorText.Length > 0) errorText += "\r\n";
                        errorText += "Designation Date is too far in the past";
                        retVal = false;
                        txtDateDesignation.BackColor = UWWTD2008.ColError;
                    }
                    else if (date.CompareTo(UWWTD2008.MAX_VALID_DATE) > 0)
                    {
                        if (errorText.Length > 0) errorText += "\r\n";
                        errorText += "Designation Date is too far in the future";
                        retVal = false;
                        txtDateDesignation.BackColor = UWWTD2008.ColError;
                    }
                    else
                        txtDateDesignation.BackColor = UWWTD2008.ColNorm;

                }
                else
                    txtDateDesignation.BackColor = UWWTD2008.ColNorm;
            }

            if ((txtGIS.Text == null) || (txtGIS.Text.Length < 1)) {
                if (errorText.Length > 0) errorText += "\r\n";
                errorText += "GIS Data is Master Data";
                retVal = false;
                txtGIS.BackColor = UWWTD2008.ColError;
            }
            else {
                txtGIS.BackColor = UWWTD2008.ColNorm;
            }

            if (!ckbANitro.Checked && !ckbAPhos.Checked && !ckbB.Checked && !ckbC.Checked) {
                if (errorText.Length > 0) errorText += "\r\n";
                errorText += "Designation Criteria is Master Data";
                retVal = false;
                ckbANitro.BackColor = UWWTD2008.ColError;
                ckbAPhos.BackColor = UWWTD2008.ColError;
                ckbB.BackColor = UWWTD2008.ColError;
                ckbC.BackColor = UWWTD2008.ColError;
            }
            else {
                ckbANitro.BackColor = UWWTD2008.ColNorm;
                ckbAPhos.BackColor = UWWTD2008.ColNorm;
                ckbB.BackColor = UWWTD2008.ColNorm;
                ckbC.BackColor = UWWTD2008.ColNorm;
            }
            
            

            return retVal;
        }
    }
}
