﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using at.uba.uwwtd2008.DataAccess;

namespace at.uba.uwwtd2008.components
{
    public partial class CtrlSplitterPanel : UserControl
    {
        delegate void CloseDataLoadDialog();

        private CtrlFileControl ctrlFileControl = null;

        #region Standard Edit Forms
        private at.uba.uwwtd2008.components.CtrlAgglomerationsEdit   ctrlAgglomerationsEdit;
        private at.uba.uwwtd2008.components.CtrlReceivingAreasEdit   ctrlReceivingAreasEdit;
        private at.uba.uwwtd2008.components.CtrlMemberStateLevelEdit ctrlMemberStateLevelEdit;
        private at.uba.uwwtd2008.components.CtrlUWWTDEdit            ctrlUWWTDEdit;
        private at.uba.uwwtd2008.components.CtrlDischargePointsEdit  ctrlDischargePointsEdit;
        private at.uba.uwwtd2008.components.CtrlRaArt23Edit          ctrlRaArt23Edit;
        private at.uba.uwwtd2008.components.CtrlRaArt5854            ctrlRaArt5854;
        //private at.uba.uwwtd2008.components.CtrlSAEdit               ctrlSAEdit;
        private at.uba.uwwtd2008.components.CtrlBigCityEdit          ctrlBigCity;
        private at.uba.uwwtd2008.components.CtrlIndustryEdit         ctrlIndustry;
        private at.uba.uwwtd2008.components.CtrlCollectionEdit       ctrlCollection;
        private at.uba.uwwtd2008.components.CtrlTreatment            ctrlTreatment;
        private at.uba.uwwtd2008.components.CtrlLoadsTreated         ctrlLoadsTreated;
        private at.uba.uwwtd2008.components.CtrlIASEdit              ctrlIAS;
        private at.uba.uwwtd2008.components.CtrlLeaksStormWaterEdit  ctrlLeaksStormWater;
        private at.uba.uwwtd2008.components.CtrlRaSA                 ctrlRaSA;
        private at.uba.uwwtd2008.components.CtrlRaLSA                ctrlRaLSA;
        private at.uba.uwwtd2008.components.CtrlRA54                 ctrlRa54;
        private at.uba.uwwtd2008.components.CtrlDPWithoutTreatment   ctrlDPWithoutTreatment;
        private at.uba.uwwtd2008.components.CtrlArt17Data            ctrlArt17Data;
        private at.uba.uwwtd2008.components.CtrlSituationReport      ctrlSituationReport;
        #endregion

        private DataLoadForm dataLoadForm = null;

        private DataSet dataSet = null;

        private UWWTDBaseCtrl currentControl = null;

        public CtrlSplitterPanel()
        {
            InitializeComponent();
            ctrlFileControl = new CtrlFileControl();

            // Initialize Sub-Components
            this.ctrlAgglomerationsEdit = new at.uba.uwwtd2008.components.CtrlAgglomerationsEdit();
            this.ctrlReceivingAreasEdit = new at.uba.uwwtd2008.components.CtrlReceivingAreasEdit();
            this.ctrlMemberStateLevelEdit = new at.uba.uwwtd2008.components.CtrlMemberStateLevelEdit();
            this.ctrlUWWTDEdit = new at.uba.uwwtd2008.components.CtrlUWWTDEdit();
            this.ctrlDischargePointsEdit = new at.uba.uwwtd2008.components.CtrlDischargePointsEdit();
            this.ctrlRaArt23Edit = new at.uba.uwwtd2008.components.CtrlRaArt23Edit();
            this.ctrlRaArt5854 = new at.uba.uwwtd2008.components.CtrlRaArt5854();
            this.ctrlBigCity = new at.uba.uwwtd2008.components.CtrlBigCityEdit();
            this.ctrlIndustry = new at.uba.uwwtd2008.components.CtrlIndustryEdit();
            this.ctrlCollection = new at.uba.uwwtd2008.components.CtrlCollectionEdit();
            this.ctrlTreatment = new at.uba.uwwtd2008.components.CtrlTreatment();
            this.ctrlLoadsTreated = new at.uba.uwwtd2008.components.CtrlLoadsTreated();
            this.ctrlIAS = new at.uba.uwwtd2008.components.CtrlIASEdit();
            this.ctrlLeaksStormWater = new at.uba.uwwtd2008.components.CtrlLeaksStormWaterEdit();
            this.ctrlRaSA = new at.uba.uwwtd2008.components.CtrlRaSA();
            this.ctrlRaLSA = new at.uba.uwwtd2008.components.CtrlRaLSA();
            this.ctrlRa54 = new at.uba.uwwtd2008.components.CtrlRA54();
            this.ctrlDPWithoutTreatment = new at.uba.uwwtd2008.components.CtrlDPWithoutTreatment();
            this.ctrlArt17Data = new at.uba.uwwtd2008.components.CtrlArt17Data();
            this.ctrlSituationReport = new at.uba.uwwtd2008.components.CtrlSituationReport();

            ctrlFileControl.Name = "Manage Files";

            this.ctrlAgglomerationsEdit.Name = "Agglomerations";
            this.ctrlReceivingAreasEdit.Name = "Receiving Areas";
            this.ctrlMemberStateLevelEdit.Name = "Member State Level";
            this.ctrlUWWTDEdit.Name = "UWWTD Master Data";
            this.ctrlDischargePointsEdit.Name = "Discharge Points";
            this.ctrlRaArt23Edit.Name = "Information of Art. 5(8) + 5(2-3)";
            this.ctrlRaArt5854.Name = "Information of Art. 5(8) + 5(4)";
            this.ctrlBigCity.Name = "Big City/big Discharger";
            this.ctrlIndustry.Name = "Information on Member State Level";
            this.ctrlCollection.Name = "Collection, Conduction and Connection";
            this.ctrlTreatment.Name = "Treatment in UWWTPs";
            this.ctrlLoadsTreated.Name = "Loads treated and discharged in UWWTPs";
            this.ctrlIAS.Name = "Individual and Appropriate Systems";
            this.ctrlLeaksStormWater.Name = "Management of leaks ans storm water overflows";
            this.ctrlRaSA.Name = "Sensitive Areas and Catchments of Sensitive Areas";
            this.ctrlRaLSA.Name = "Less Sensitive Area";
            this.ctrlRa54.Name = "Application of Art5(4)";
            this.ctrlDPWithoutTreatment.Name = "Master data of discharge point without treatment";
            this.ctrlArt17Data.Name = "Art.17 Data";
            this.ctrlSituationReport.Name = "Situation Report";

            if (UWWTDBaseCtrl.CurrentRep != null)
            {
                setMemberState(UWWTDBaseCtrl.CurrentRep.Reporter.State.Value);
                UpdateDataSet();
            } 

        }

        public void UpdateDataSet()
        {
            System.Threading.Thread t = new System.Threading.Thread(new System.Threading.ThreadStart(showDataLoadDialog));
            t.Start();
            try
            {
                if (dataSet != null)
                {
                    dataSet.Dispose();
                }

                dataSet = new DataSet();
                //if (dataSet == null)
                //{
                //}
                //else
                //{
                //    dataSet.BeginInit();
                //    dataSet.EnforceConstraints = false;
                //    dataSet.Relations.Clear();
                //    dataSet.Tables.Clear();
                //    dataSet.EnforceConstraints = true;
                //}
                updateUWWAggloTable(dataSet);

                ctrlBigCity.PerformDataBinding(dataSet);
                ctrlAgglomerationsEdit.PerformDataBinding(dataSet);
                ctrlUWWTDEdit.PerformDataBinding(dataSet);
                ctrlIndustry.PerformDataBinding(dataSet);
                ctrlCollection.PerformDataBinding(dataSet);
                ctrlTreatment.PerformDataBinding(dataSet);
                ctrlLoadsTreated.PerformDataBinding(dataSet);
                ctrlIAS.PerformDataBinding(dataSet);
                ctrlLeaksStormWater.PerformDataBinding(dataSet);

                ctrlReceivingAreasEdit.PerformDataBinding(dataSet);
                ctrlDischargePointsEdit.PerformDataBinding(dataSet);
                ctrlRaArt23Edit.PerformDataBinding(dataSet);
                ctrlRaArt5854.PerformDataBinding(dataSet);
                ctrlRaSA.PerformDataBinding(dataSet);
                ctrlRaLSA.PerformDataBinding(dataSet);
                ctrlRa54.PerformDataBinding(dataSet);
                ctrlDPWithoutTreatment.PerformDataBinding(dataSet);
                ctrlMemberStateLevelEdit.PerformDataBinding(dataSet);
            }
            finally
            {
                finishedDataLoading();
            }
        }

        public void updateUWWAggloTable(DataSet dataSet)
        {
            if (UWWTDBaseCtrl.CurrentRep == null) return;
            if (dataSet == null) return;
            DataAccessFactory dataFactory = DataAccessFactory.Instance;

            IDbConnection conn = dataFactory.GetConnection();
            try
            {
                bool newDataSet = false;
                IDbDataAdapter adapter = null;
                long currentRepID = UWWTDBaseCtrl.CurrentRep.RepID;
                // first: load UWWTDS and AGGLO - Tables;
                if (!dataSet.Tables.Contains(CtrlAgglomerationsEdit.TNAME_AGGLO))
                {
                    adapter = dataFactory.CreateDataAdapter(dataFactory.CreateCommand(CtrlAgglomerationsEdit.SelectString + currentRepID, conn));
                    dataFactory.FillDataAdapter(adapter, dataSet, CtrlAgglomerationsEdit.TNAME_AGGLO);
                    newDataSet = true;
                }
                if (!dataSet.Tables.Contains(CtrlUWWTDEdit.TNAME_UWWTDS))
                {
                    adapter = dataFactory.CreateDataAdapter(dataFactory.CreateCommand(CtrlUWWTDEdit.SELECT_ALL_UWWTD + currentRepID, conn));
                    dataFactory.FillDataAdapter(adapter, dataSet, CtrlUWWTDEdit.TNAME_UWWTDS);
                    newDataSet = true;
                }

                // then - load the UWWTD-Agglo Table
                bool isConstraintsEnforced = dataSet.EnforceConstraints;
                dataSet.EnforceConstraints = false;
                adapter = dataFactory.CreateFullDataAdapter(dataFactory.CreateCommand(CtrlUWWTDEdit.SELECT_ALL_UWWTDAGGLO + currentRepID, conn));
                dataFactory.FillDataAdapter(adapter, dataSet, CtrlUWWTDEdit.TNAME_UWWTDAGGLO);
                foreach (DataRow row in dataSet.Tables[CtrlUWWTDEdit.TNAME_UWWTDAGGLO].Rows)
                {
                    if ((dataSet.Tables[CtrlAgglomerationsEdit.TNAME_AGGLO].Rows.Find(row["aggID"]) == null) || 
                        (dataSet.Tables[CtrlUWWTDEdit.TNAME_UWWTDS].Rows.Find(row["uwwID"]) == null))
                    {
                        row.Delete();
                    }
                }
                dataFactory.UpdateDataAdapter(adapter, dataSet, CtrlUWWTDEdit.TNAME_UWWTDAGGLO);

                if (!dataSet.Tables.Contains(CtrlDischargePointsEdit.TNAME_DISCPOINTS))
                {
                    adapter = dataFactory.CreateFullDataAdapter(dataFactory.CreateCommand(CtrlDischargePointsEdit.SELECT_DISCPOINTS + currentRepID, conn));
                    dataFactory.FillDataAdapter(adapter, dataSet, CtrlDischargePointsEdit.TNAME_DISCPOINTS);
                    foreach (DataRow row in dataSet.Tables[CtrlDischargePointsEdit.TNAME_DISCPOINTS].Rows)
                    {
                        if (dataSet.Tables[CtrlUWWTDEdit.TNAME_UWWTDS].Rows.Find(row["uwwID"]) == null)
                        {
                            row.Delete();
                        }
                    }
                    dataFactory.UpdateDataAdapter(adapter, dataSet, CtrlDischargePointsEdit.TNAME_DISCPOINTS);
                }

                if (!newDataSet)
                {
                    ctrlAgglomerationsEdit.UpdateUwwAgglo(dataSet, conn);
                    ctrlUWWTDEdit.UpdateUwwAgglo(dataSet, conn);
                    ctrlCollection.UpdateUwwAgglo(dataSet, conn);
                }
                dataSet.EnforceConstraints = isConstraintsEnforced;
            }
            finally
            {
                conn.Close();
            }

        }

        private void finishedDataLoading() {
            if (dataLoadForm == null) return;
            if (dataLoadForm.InvokeRequired)
            {
                dataLoadForm.Invoke(new CloseDataLoadDialog(finishedDataLoading));
            }
            else
            {
                dataLoadForm.Visible = false;
                dataLoadForm.Dispose();
                dataLoadForm = null;
            }
        }

        private void showDataLoadDialog()
        {
            dataLoadForm = new DataLoadForm();
            dataLoadForm.ShowDialog();
        }

        public void repositionMainPanel()
        {
            int xpos = (this.Width - pictureBox1.Width) / 2;
            if (xpos < 0) xpos = 0;
            pictureBox1.Left = xpos;

            int xtxtpos = xpos + pictureBox1.Width + 5;
            int xwidth = this.Width - xtxtpos;
            labelTextCommission.Width = xwidth;
            labelTextCommission.Left = xtxtpos;

            xwidth = xpos - 5 - labelMemberState.Left;
            labelMemberState.Width = xwidth;

            labelTitle.Width = Width;
            labelTitle.Left = 0;

            panelContent.Width = Width;
            panelContent.Height = Height - panelContent.Top;
        }

        protected void repositionContentPanel()
        {
            if (panelContent.Controls.Count <= 0) return; // nothing to do in that case
            Control ctrl = panelContent.Controls[0];
            if ((ctrl is UserControl) && (((UserControl)ctrl).AutoSize))
            {
                ctrl.Left = 0;
                ctrl.Top = 0;
                return;
            }
            int xpos = (panelContent.Width - ctrl.Width) / 2;
            int ypos = (panelContent.Height - ctrl.Height) / 2;
            if (xpos < 0) xpos = 0;
            if (ypos < 0) ypos = 0;

            ctrl.Left = xpos;
            ctrl.Top = ypos;
        }

        private void OnSizeChanged(object sender, EventArgs e)
        {
            repositionMainPanel();
        }

        private void OnContentSizeChanged(object sender, EventArgs e)
        {
            repositionContentPanel();
        }

        public void setContentPane(UWWTDBaseCtrl ctrl)
        {
            // if the new form is the actual form - do not add it
            // Correct the form Title
            labelTitle.Text = ctrl.Name;

            panelContent.Controls.Clear();
            currentControl = ctrl;
            panelContent.Controls.Add(ctrl);
            ctrl.OpenForm();

            // Set the name of the actual form in the Status bar
            UWWTD2008MainForm mf = UWWTD2008MainForm.getMainForm(this);
            if (mf != null) mf.setStatusText(ctrl.Name);

            // Reposition the content for viewing
            repositionContentPanel();
            repositionContentPanel();

        }

        public void setMemberState(string memberState)
        {
            if (memberState != null)
                labelMemberState.Text = memberState;
            else
                labelMemberState.Text = "";
        }

        public bool IsCurrentForm(UWWTDBaseCtrl control) {
            return currentControl == control;
        }

        public void OpenAgglomerationsEdit()
        {
            setContentPane(ctrlAgglomerationsEdit);
        }

        public void OpenReceivingAreasEdit()
        {
            setContentPane(ctrlReceivingAreasEdit);
        }

        public void OpenMemberStateLevelEdit()
        {
            setContentPane(ctrlMemberStateLevelEdit);
        }

        public void OpenUWWTDEdit(UWWTDBaseCtrl predecessor) {
            ctrlUWWTDEdit.PrevControl = predecessor;
            setContentPane(ctrlUWWTDEdit);
        }

        public void OpenTreatment(UWWTDBaseCtrl predecessor)
        {
            ctrlTreatment.PrevControl = predecessor;
            setContentPane(ctrlTreatment);
        }

        public void OpenLoadsTreated(UWWTDBaseCtrl predecessor)
        {
            ctrlLoadsTreated.PrevControl = predecessor;
            setContentPane(ctrlLoadsTreated);
        }

        public void OpenDischargePointsEdit(UWWTDBaseCtrl predecessor)
        {
            ctrlDischargePointsEdit.PrevControl = predecessor;
            setContentPane(ctrlDischargePointsEdit);
        }

        public void OpenRaArt23Edit(UWWTDBaseCtrl predecessor)
        {
            ctrlRaArt23Edit.PrevControl = predecessor;
            setContentPane(ctrlRaArt23Edit);
        }

        public void OpenRaArt5854Edit(UWWTDBaseCtrl predecessor)
        {
            ctrlRaArt5854.PrevControl = predecessor;
            setContentPane(ctrlRaArt5854);
        }

        public void OpenSAEdit(UWWTDBaseCtrl predecessor)
        {
            ctrlRaSA.PrevControl = predecessor;
            setContentPane(ctrlRaSA);
        }

        public void OpenRa54Edit(UWWTDBaseCtrl predecessor)
        {
            ctrlRa54.PrevControl = predecessor;
            setContentPane(ctrlRa54);
        }

        public void OpenDPWithoutTreatmentEdit(UWWTDBaseCtrl predecessor)
        {
            ctrlDPWithoutTreatment.PrevControl = predecessor;
            setContentPane(ctrlDPWithoutTreatment);
        }

        public void OpenLSAEdit(UWWTDBaseCtrl predecessor)
        {
            ctrlRaLSA.PrevControl = predecessor;
            setContentPane(ctrlRaLSA);
        }

        public void OpenEditBigCity(UWWTDBaseCtrl predecessor)
        {
            ctrlBigCity.PrevControl = predecessor;
            setContentPane(ctrlBigCity);
        }

        public void OpenEditIndustry(UWWTDBaseCtrl predecessor)
        {
            ctrlIndustry.PrevControl = predecessor;
            setContentPane(ctrlIndustry);
        }

        public void OpenEditCollection(UWWTDBaseCtrl predecessor)
        {
            ctrlCollection.PrevControl = predecessor;
            setContentPane(ctrlCollection);
        }

        public void OpenEditIAS(UWWTDBaseCtrl predecessor) {
            ctrlIAS.PrevControl = predecessor;
            setContentPane(ctrlIAS);
        }

        public void OpenEditLeaksStormWater(UWWTDBaseCtrl predecessor) {
            ctrlLeaksStormWater.PrevControl = predecessor;
            setContentPane(ctrlLeaksStormWater);
        }

        public void OpenFileControl(UWWTDBaseCtrl predecessor)
        {
            ctrlFileControl.PrevControl = predecessor;
            setContentPane(ctrlFileControl);
        }

        public void OpenArt17Data(UWWTDBaseCtrl predecessor) {
            ctrlArt17Data.PrevControl = predecessor;
            setContentPane(ctrlArt17Data);
        }

        public void OpenSituationReport(UWWTDBaseCtrl predecessor)
        {
            ctrlArt17Data.PrevControl = predecessor;
            setContentPane(ctrlSituationReport);
        }

        private void OnBackItemClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            foreach (Control c in panelContent.Controls)
            {
                if (c is UWWTDBaseCtrl)
                {
                    ((UWWTDBaseCtrl)c).OnBackButtonClick();
                }
            }
        }


 /*       internal void OpenCtrlRaArt23Edit(UWWTDBaseCtrl predecessor)
        {
            throw new NotImplementedException();
        }*/
    }
}
