﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace at.uba.uwwtd2008.components {
    public partial class CtrlTreatment : UWWTDBaseCtrl {
        private DataSet dataSet;
        private EventHandler uwwtdPositionChanged = null;
        public const string RNAME_UWWTD_DP = CtrlUWWTDEdit.RNAME_DP_UWWTD;

        public CtrlTreatment() {
            uwwtdPositionChanged = new EventHandler(CurrentUWWTDChanged);
            InitializeComponent();
        }

        public override void OnBackButtonClick() {
            UWWTD2008MainForm mf = UWWTD2008MainForm.getMainForm(this);
            if (mf == null) return;

            BindingContext[dataSet, CtrlAgglomerationsEdit.TNAME_AGGLO + "." + CtrlCollectionEdit.RNAME_AGGLO_UWWAGGLO].PositionChanged -= uwwtdPositionChanged;

            if (PrevControl != null) mf.getSplitterPanel().setContentPane(PrevControl);
            else mf.OpenDataEditMain();
        }

        private void OnOpenLoadsTreated(object sender, LinkLabelLinkClickedEventArgs e) {
            ((UWWTD2008MainForm)(this.Parent.Parent.Parent.Parent)).OpenLoadsTreated(this);
        }

        public override void OpenForm()
        {
            this.BindingContext[dataSet, CtrlAgglomerationsEdit.TNAME_AGGLO].Position = PrevControl.BindingContext[dataSet, CtrlAgglomerationsEdit.TNAME_AGGLO].Position;
            this.BindingContext[dataSet, CtrlUWWTDEdit.TNAME_UWWTDS].Position = PrevControl.BindingContext[dataSet, CtrlUWWTDEdit.TNAME_UWWTDS].Position;

            BindingContext[dataSet, CtrlAgglomerationsEdit.TNAME_AGGLO + "." + CtrlCollectionEdit.RNAME_AGGLO_UWWAGGLO].PositionChanged += uwwtdPositionChanged;

            panStringent.Enabled = ckbOtherTreatment.CheckState == CheckState.Checked;
            txtSpecification.Enabled = ckbOther.CheckState == CheckState.Checked;
        }

        public override void PerformDataBinding(DataSet dataSet)
        {
            //bool hasNewItems = false;
            this.dataSet = dataSet;

            // Create Data Relations
            DataColumn dc1, dc2;
            DataRelation rel;

            if (!dataSet.Relations.Contains(RNAME_UWWTD_DP))
            {
                dc1 = dataSet.Tables[CtrlUWWTDEdit.TNAME_UWWTDS].Columns["uwwID"];
                dc2 = dataSet.Tables[CtrlDischargePointsEdit.TNAME_DISCPOINTS].Columns["uwwID"];
                rel = new DataRelation(RNAME_UWWTD_DP, dc1, dc2);
                dataSet.Relations.Add(rel);
            }

            dgvUwwtpList.AutoGenerateColumns = false;
            dgvUwwtpList.DataSource = dataSet;
            dgvUwwtpList.DataMember = CtrlAgglomerationsEdit.TNAME_AGGLO + "." + CtrlCollectionEdit.RNAME_AGGLO_UWWAGGLO;

            txtUwwCode.DataBindings.Clear();
            txtUwwCode.DataBindings.Add("Text", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwCode");
            txtUwwName.DataBindings.Clear();
            txtUwwName.DataBindings.Add("Text", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwName");
            txtLoadEnteringUWWTPT.DataBindings.Clear();
            txtLoadEnteringUWWTPT.DataBindings.Add("Text", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwLoadEnteringUWWTP");
            txtCapacity.DataBindings.Clear();
            txtCapacity.DataBindings.Add("Text", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwCapacity");
            ckbPrimaryTreatment.DataBindings.Clear();
            ckbPrimaryTreatment.DataBindings.Add("Checked", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwPrimaryTreatment");
            ckbSecondaryTreatment.DataBindings.Clear();
            ckbSecondaryTreatment.DataBindings.Add("Checked", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwSecondaryTreatment");
            ckbOtherTreatment.DataBindings.Clear();
            ckbOtherTreatment.DataBindings.Add("Checked", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwOtherTreatment");
            ckbOtherTreatment.CheckStateChanged += new EventHandler(OtherTreatmentCheckChanged);

            ckbPRemoval.DataBindings.Clear();
            ckbPRemoval.DataBindings.Add("Checked", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwPRemoval");
            ckbNRemoval.DataBindings.Clear();
            ckbNRemoval.DataBindings.Add("Checked", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwNRemoval");
            ckbUV.DataBindings.Clear();
            ckbUV.DataBindings.Add("Checked", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwUV");
            ckbChlorination.DataBindings.Clear();
            ckbChlorination.DataBindings.Add("Checked", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwChlorination");
            ckbOzonation.DataBindings.Clear();
            ckbOzonation.DataBindings.Add("Checked", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwOzonation");
            ckbSandFiltration.DataBindings.Clear();
            ckbSandFiltration.DataBindings.Add("Checked", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwSandFiltration");
            ckbMicroFiltration.DataBindings.Clear();
            ckbMicroFiltration.DataBindings.Add("Checked", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwMicroFiltration");
            ckbOther.DataBindings.Clear();
            ckbOther.DataBindings.Add("Checked", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwOther");
            ckbOther.CheckStateChanged += new EventHandler(OtherTreatmentCheckChanged);

            txtSpecification.DataBindings.Clear();
            txtSpecification.DataBindings.Add("Text", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwSpecification");

            cmbTSSPerf.DataSource = mDataFactory.getPASSLovValues();
            cmbTSSPerf.DisplayMember = "lovWert";
            cmbTSSPerf.ValueMember = "lovID";
            cmbTSSPerf.DataBindings.Clear();
            cmbTSSPerf.DataBindings.Add("SelectedValue", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwTSSPerf");

            cmbBOD5Perf.DataSource = mDataFactory.getLovViewByKey("BOD5");
            cmbBOD5Perf.DisplayMember = "lovWert";
            cmbBOD5Perf.ValueMember = "lovID";
            cmbBOD5Perf.DataBindings.Clear();
            cmbBOD5Perf.DataBindings.Add("SelectedValue", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwBOD5Perf");

            cmbCODPerf.DataSource = mDataFactory.getPASSLovValues();
            cmbCODPerf.DisplayMember = "lovWert";
            cmbCODPerf.ValueMember = "lovID";
            cmbCODPerf.DataBindings.Clear();
            cmbCODPerf.DataBindings.Add("SelectedValue", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwCODPerf");

            cmbNTotPerf.DataSource = mDataFactory.getPASSLovValues();
            cmbNTotPerf.DisplayMember = "lovWert";
            cmbNTotPerf.ValueMember = "lovID";
            cmbNTotPerf.DataBindings.Clear();
            cmbNTotPerf.DataBindings.Add("SelectedValue", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwNTotPerf");

            cmbPTotPerf.DataSource = mDataFactory.getPASSLovValues();
            cmbPTotPerf.DisplayMember = "lovWert";
            cmbPTotPerf.ValueMember = "lovID";
            cmbPTotPerf.DataBindings.Clear();
            cmbPTotPerf.DataBindings.Add("SelectedValue", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwPTotPerf");

            cmbOtherPerf.DataSource = mDataFactory.getPASSLovValues();
            cmbOtherPerf.DisplayMember = "lovWert";
            cmbOtherPerf.ValueMember = "lovID";
            cmbOtherPerf.DataBindings.Clear();
            cmbOtherPerf.DataBindings.Add("SelectedValue", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwOtherPerf");

            ckbBadPerformance.DataBindings.Clear();
            ckbBadPerformance.DataBindings.Add("Checked", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwBadPerformance");
            ckbAccidents.DataBindings.Clear();
            ckbAccidents.DataBindings.Add("Checked", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwAccidents");
            ckbBadDesign.DataBindings.Clear();
            ckbBadDesign.DataBindings.Add("Checked", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwBadDesign");

            txtInformation.DataBindings.Clear();
            txtInformation.DataBindings.Add("Text", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwInformation");

            gridDischargePoints.AutoGenerateColumns = false;
            gridDischargePoints.DataSource = dataSet;
            gridDischargePoints.DataMember = CtrlUWWTDEdit.TNAME_UWWTDS + "." + RNAME_UWWTD_DP;
            ((DataGridViewComboBoxColumn)gridDischargePoints.Columns["dgvRcaType"]).DataSource = mDataFactory.getRATYPLovValues();
            ((DataGridViewComboBoxColumn)gridDischargePoints.Columns["dgvRcaType"]).DisplayMember = "lovWert";
            ((DataGridViewComboBoxColumn)gridDischargePoints.Columns["dgvRcaType"]).ValueMember = "lovID";
            // TODO HPW: add code here

            txtRemarks.DataBindings.Clear();
            txtRemarks.DataBindings.Add("Text", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwRemarks");
            txtDateClosing.DataBindings.Clear();
            txtDateClosing.DataBindings.Add("Text", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwDateClosing", true, DataSourceUpdateMode.OnValidation, "", "d");
            txtHistorie.DataBindings.Clear();
            txtHistorie.DataBindings.Add("Text", dataSet, CtrlUWWTDEdit.TNAME_UWWTDS + ".uwwHistorie");
        }

        void CurrentUWWTDChanged(object sender, EventArgs e)
        {
            if (BindingContext[dataSet, CtrlAgglomerationsEdit.TNAME_AGGLO + "." + CtrlCollectionEdit.RNAME_AGGLO_UWWAGGLO].Position < 0)
            {
                BindingContext[dataSet, CtrlUWWTDEdit.TNAME_UWWTDS].Position = -1;
                return;
            }

            DataRowView row = BindingContext[dataSet, CtrlAgglomerationsEdit.TNAME_AGGLO + "." + CtrlCollectionEdit.RNAME_AGGLO_UWWAGGLO].Current as DataRowView;
            if (row == null)
            {
                BindingContext[dataSet, CtrlUWWTDEdit.TNAME_UWWTDS].Position = -1;
                return;
            }

            DataRow uwwRow = dataSet.Tables[CtrlUWWTDEdit.TNAME_UWWTDS].Rows.Find(row["uwwID"]);
            if (uwwRow == null)
            {
                BindingContext[dataSet, CtrlUWWTDEdit.TNAME_UWWTDS].Position = -1;
                return;
            }

            BindingContext[dataSet, CtrlUWWTDEdit.TNAME_UWWTDS].Position = dataSet.Tables[CtrlUWWTDEdit.TNAME_UWWTDS].Rows.IndexOf(uwwRow);
        }

        void OtherTreatmentCheckChanged(object sender, EventArgs e)
        {
            if (sender == ckbOtherTreatment)
                panStringent.Enabled = ckbOtherTreatment.CheckState == CheckState.Checked;
            if (sender == ckbOther)
                txtSpecification.Enabled = ckbOther.CheckState == CheckState.Checked;

        }

        private void OnDelete(object sender, LinkLabelLinkClickedEventArgs e)
        {
            if (ShowConfirmDelete()) {
                if (BindingContext[dataSet, CtrlUWWTDEdit.TNAME_UWWTDS].Position < 0) return;
                DataRowView currentUWWTP = BindingContext[dataSet, CtrlUWWTDEdit.TNAME_UWWTDS].Current as DataRowView;
                if (currentUWWTP == null) return;

                currentUWWTP["uwwLoadEnteringUWWTP"] = dataSet.Tables[CtrlUWWTDEdit.TNAME_UWWTDS].Columns["uwwLoadEnteringUWWTP"].DefaultValue;
                currentUWWTP["uwwCapacity"] = dataSet.Tables[CtrlUWWTDEdit.TNAME_UWWTDS].Columns["uwwCapacity"].DefaultValue;
                currentUWWTP["uwwPrimaryTreatment"] = false;
                currentUWWTP["uwwSecondaryTreatment"] = false;
                currentUWWTP["uwwOtherTreatment"] = false;
                currentUWWTP["uwwNRemoval"] = false;
                currentUWWTP["uwwPRemoval"] = false;
                currentUWWTP["uwwUV"] = false;
                currentUWWTP["uwwChlorination"] = false;
                currentUWWTP["uwwOzonation"] = false;
                currentUWWTP["uwwSandFiltration"] = false;
                currentUWWTP["uwwMicroFiltration"] = false;
                currentUWWTP["uwwOther"] = false;
                currentUWWTP["uwwSpecification"] = false;
                currentUWWTP["uwwOther"] = false;
                currentUWWTP["uwwTSSPerf"] = DBNull.Value;
                currentUWWTP["uwwBOD5Perf"] = DBNull.Value;
                currentUWWTP["uwwCODPerf"] = DBNull.Value;
                currentUWWTP["uwwNTotPerf"] = DBNull.Value;
                currentUWWTP["uwwPTotPerf"] = DBNull.Value;
                currentUWWTP["uwwOtherPerf"] = DBNull.Value;
                currentUWWTP["uwwOtherPerf"] = DBNull.Value;
                currentUWWTP["uwwBadPerformance"] = false;
                currentUWWTP["uwwAccidents"] = false;
                currentUWWTP["uwwBadDesign"] = false;
                currentUWWTP["uwwInformation"] = DBNull.Value;
                currentUWWTP["uwwRemarks"] = DBNull.Value;
                currentUWWTP["uwwDateClosing"] = DBNull.Value;
                currentUWWTP["uwwHistorie"] = DBNull.Value;

                OnSaveTreatment(null, null);
            }

        }

        private void OnSaveTreatment(object sender, LinkLabelLinkClickedEventArgs e) {
            DataRowView row = BindingContext[dataSet, CtrlUWWTDEdit.TNAME_UWWTDS].Current as DataRowView;

            string strErrorText = "";
            if (sender != null)
                if (!ValidateForm(ref strErrorText, row.Row.RowState)) {
                    MessageBox.Show(this, "Please correct Form Errors before save:\r\n" + strErrorText, "Form not valid", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                    return;
                }

            if (row != null) row.EndEdit();

            IDbConnection conn = mDataFactory.GetConnection();
            try {
                bool enforceConstraints = dataSet.EnforceConstraints;
                IDbDataAdapter adapter = null;
                dataSet.EnforceConstraints = false;
                try {
                    int curPos = BindingContext[dataSet, CtrlUWWTDEdit.TNAME_UWWTDS].Position;
                    adapter = mDataFactory.CreateFullDataAdapter(mDataFactory.CreateCommand(CtrlUWWTDEdit.SELECT_ALL_UWWTD + CurrentRep.RepID, conn));
                    mDataFactory.UpdateDataAdapter(adapter, dataSet, CtrlUWWTDEdit.TNAME_UWWTDS);
                    mDataFactory.FillDataAdapter(adapter, dataSet, CtrlUWWTDEdit.TNAME_UWWTDS);
                    if (BindingContext[dataSet, CtrlUWWTDEdit.TNAME_UWWTDS].Count >= 1) {
                        BindingContext[dataSet, CtrlUWWTDEdit.TNAME_UWWTDS].Position = curPos;
                        PrevControl.BindingContext[dataSet, CtrlUWWTDEdit.TNAME_UWWTDS].Position = curPos;
                    }
                }
                finally {
                    dataSet.EnforceConstraints = enforceConstraints;
                }
            }
            finally {
                conn.Close();
            }

            if (sender != null)
                ShowSaveConfirmation();

        }
    }
}
